$!	**** ACCTFY81.COM ****
$!
$!*****************************************************************
$!** Sample command file to run yearly totals to date.  This     **
$!** command proc. will average all of the existing averaged     **
$!** disk usage files.						 **
$!*****************************************************************
$!
$!  This command file is designed to link all of the required 
$!  accounting files to determine the charges incurred by the
$!  users of the AFWL/ARL VAX.  This command file was updated
$!  for use with VMS V2.0 on 29 Oct 1980 by R. Olds.
$!
$!  Modifications:
$!  ==============
$!	04-May-1981	Do a complete fiscal charge run to current
$!			date total using disk space for Jan as
$!			disk usage wag.
$!	10-May-1981	Use all precomputed averaged disk data files
$!			for the users disk usage file.
$!
$ VER_MODE := 'F$VERIFY()'
$ SET NOVERIFY
$!
$ YEAR		:= "FY81" ! Fiscal Year ID in format of FYlast 2 dig. of year
$!
$ YEAR_ID	:= 'F$EXTRACT(2,2,YEAR)'
$ END_YR	= 1900 + 'YEAR_ID'
$ STR_YR	= END_YR - 1
$!
$ BASE_DIR	:= "DISK$SYSTEM:[SYSMGR.ACCOUNT]"
$ DATA_DIR	:= "DISK$SYSTEM:[SYSMGR.ACCOUNT.''YEAR']"
$ DISK_DIR	:= "DISK$SYSTEM:[SYSMGR.ACCOUNT.''YEAR']"
$!
$ SET DEF 'BASE_DIR'
$!
$!  Set parameters for accounting packages
$!
$ LOWTIME	:= "1-OCT-''STR_YR' 0:0:0.0"
$ HITIME	:= "30-SEP-''END_YR' 23:59:59.99"
$!
$!  Set remaining parameters for running ACCT_INFO
$!
$ OPEN TEST_1A 'DATA_DIR'ACCT'YEAR'.DAT/ERR=SKIP_1A
$ CLOSE TEST_1A
$ DELETE 'DATA_DIR'ACCT'YEAR'.DAT;*/LOG
$ SKIP_1A:
$!
$ OPEN TEST_1B 'DATA_DIR'ACCT'YEAR'.LIS/ERR=SKIP_1B
$ CLOSE TEST_1B
$ DELETE 'DATA_DIR'ACCT'YEAR'.LIS;*/LOG
$ SKIP_1B:
$!
$ OPEN TEST_1C 'DATA_DIR'ACCT'YEAR'.USR/ERR=SKIP_1C
$ CLOSE TEST_1C
$ DELETE 'DATA_DIR'ACCT'YEAR'.USR;*/LOG
$ SKIP_1C:
$!
$ OPEN SCRATCH_FILE 'DATA_DIR'SCRATCH.DAT /WRITE	! Pass input to ACC1
$ WRITE SCRATCH_FILE LOWTIME
$ WRITE SCRATCH_FILE HITIME
$ CLOSE SCRATCH_FILE
$!
$ ASSIGN 'DATA_DIR'ACCOUNTNG.F'YEAR_ID' INPUT_DATA	! Use Master Accounting
$!							! Data File
$ ASSIGN 'DATA_DIR'SCRATCH.DAT SCRATCH_FILE
$ ASSIGN 'DATA_DIR'ACCT'YEAR'.DAT OUTPUT_DATA
$!
$ RUN 'BASE_DIR'ACCTINFO.EXE
$!
$ DEASS INPUT_DATA
$ DEASS OUTPUT_DATA
$ DEASS SCRATCH_FILE
$ DELETE 'DATA_DIR'SCRATCH.DAT.* /LOG
$!
$!   Combine all disk data files into 1 file
$!
$ OPEN TEST_2 'DATA_DIR'ACCT'YEAR'.DSK/ERR=NO_DISK_DATA_EXISTS !Ck for dsk file
$ DELETE 'DATA_DIR'ACCT'YEAR'.DSK;*
$ CLOSE TEST_2
$!
$ NO_DISK_DATA_EXISTS:
$ OPEN DSK_FILE 'DATA_DIR'DSKUSG.DAT/ERR=NO_DSK_FILE
$ CLOSE DSK_FILE
$ DELETE 'DATA_DIR'DSKUSG.DAT;*
$ NO_DSK_FILE:
$!
$ DIRECTORY 'DISK_DIR'*.DSK;0/OUT='DATA_DIR'DSKUSG.DAT;1/COL=1/NOTRAIL
$!
$ OPEN DSK_FILE 'DATA_DIR'DSKUSG.DAT;1/ERR=ERR_DSK_DATA
$!
$ READ DSK_FILE BLANK_LINE /END=ERR_E_O_F1
$ READ DSK_FILE DIREC_NAME /END=ERR_E_O_F1
$ READ DSK_FILE BLANK_LINE /END=ERR_E_O_F1
$!
$!   Begin reading existing disk usage data filenames
$!
$ READ DSK_FILE FILE_NAME /END=ERR_E_O_F1	! Read 1st data filename
$ COPY 'DATA_DIR''FILE_NAME' 'DATA_DIR'DSKUSG.DAT;2/LOG	! Create DSKUSG.DAT
$!
$ APPEND_LOOP:
$	READ DSK_FILE FILE_NAME /END=APPEND_DONE
$	APPEND 'DATA_DIR''FILE_NAME' 'DATA_DIR'DSKUSG.DAT;2/LOG
$	GOTO APPEND_LOOP
$ APPEND_DONE:
$!
$!   Run program to average disk usage for the year to date
$!
$ ASSIGN 'DATA_DIR'DSKUSG.DAT;2 INPUT_DATA
$ ASSIGN 'DATA_DIR'DSKUSG.DAT;3 OUTPUT_DATA
$!
$ RUN DSKAVERGE
$!
$ DEASSIGN INPUT_DATA
$ DEASSIGN OUTPUT_DATA
$ RENAME 'DATA_DIR'DSKUSG.DAT;3 ACCT'YEAR'.DSK/LOG
$!
$!   Run accounting charges for entire fiscal year to date
$!   using an average value for disk usage.
$!
$ ASSIGN 'DATA_DIR'ACCT'YEAR'.DAT INPUT_DATA
$ ASSIGN 'DATA_DIR'ACCT'YEAR'.LIS OUTPUT_DATA
$ ASSIGN 'DATA_DIR'ACCT'YEAR'.DSK DISK_DATA
$ ASSIGN 'DATA_DIR'ACCT'YEAR'.USR OUTPUT_DATA2
$!
$ RUN VAXUSE
$!
$ DEASSIGN INPUT_DATA
$ DEASSIGN OUTPUT_DATA
$ DEASSIGN DISK_DATA
$ DEASSIGN OUTPUT_DATA2
$!
$ EXIT_ALL:				! Begin exit here if run was OK
$!
$	PRINT 'DATA_DIR'ACCT'YEAR'.LIS
$	PRINT 'DATA_DIR'ACCT'YEAR'.USR
$!
$ EXIT_ERR:				! Exit here if fatal error found
$!
$	DELETE 'DATA_DIR'DSKUSG.DAT;*/LOG
$	IF VER_MODE THEN SET VERIFY
$	EXIT
$!
$!	**** ERROR CONDITIONS ****
$!
$ ERR_DSK_DATA:
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "%ACCT''YEAR'-F-No disk directory found"
$	GOTO EXIT_ERR
$!
$ ERR_E_O_F1:
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT "%ACCT''YEAR'-F-No disk data files found"
$	GOTO EXIT_ERR
$!
