$!	***** COMPILE.COM *****
$!
$!  This command file is designed to compile all the required
$!  files for use by the AF Weapons Lab accounting package.
$!  If you have any problems with this accounting package, please
$!  contact:	Richard Olds
$!		Air Force Weapons Laboratory
$!		AFWL/ARLB
$!		Kirtland AFB, NM 87117
$!		(505) 844-7497
$!
$ VER_MODE = 'F$VERIFY()'
$ SET NOVERIFY
$ ON CONTROL_Y THEN GOTO EXIT_ALL
$!
$!	Compile and link program to compile VAX use statistics
$!
$ ON ERROR THEN GOTO ERR_COMPILE
$ WRITE SYS$OUTPUT " Compiling ACCTINFO program."
$ SECTION := "ACCTINFO"
$ FOR ACCTINFO/LIST
$ MAC QUADMATH/LIST
$ LINK ACCTINFO,QUADMATH
$ DELETE ACCTINFO.OBJ;*,QUADMATH.OBJ;*
$!
$!	Compile disk usage averaging program
$!
$ WRITE SYS$OUTPUT " Compiling DSKAVERGE program."
$ SECTION := "DSKAVERGE"
$ FOR DSKAVERGE/LIS
$ LINK DSKAVERGE
$ DELETE DSKAVERGE.OBJ;*
$!
$!	Compile and link program to generate user charges
$!
$ WRITE SYS$OUTPUT " Compiling VAXUSE program."
$ SECTION := "VAXUSE"
$ FOR VAXUSE/LIST/NOOP
$ LINK VAXUSE
$ DELETE VAXUSE.OBJ;*
$!
$!	Remove delete privilege for all Fortran source
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT " Removing user access and delete privileges"
$ SET PROTECTION=(SYS:RWE,OWN:RWE,GR,WOR) *.FOR;*
$ SET PROTECTION=(SYS:RWE,OWN:RWE,GR,WOR) *.EXE;*
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT " Compilation and linking of all programs for"
$ WRITE SYS$OUTPUT " AF Weapons Lab accounting package completed!"
$!
$ READ_PRINT:
$	WRITE SYS$OUTPUT ""
$	INQUIRE PRINT_OPT "Do you wish listing files printed (CR = Y)"
$	IF PRINT_OPT .EQS. "" THEN PRINT_OPT := "Y"
$	IF PRINT_OPT .EQS. "Y" THEN GOTO PRINT_LIST
$	IF PRINT_OPT .EQS. "N" THEN GOTO SKIP_PRINT
$	WRITE SYS$OUTPUT "     Please answer Y or N"
$	GOTO READ_PRINT
$!
$ PRINT_LIST:
$	ON ERROR THEN GOTO ERR_PRINT_LIST
$	PRINT ACCTINFO,QUADMATH
$	PRINT DSKAVERGE
$	PRINT VAXUSE
$ SKIP_PRINT:
$!
$ READ_DIREC:				! Open fiscal year directories
$	WRITE SYS$OUTPUT ""
$	INQUIRE DIREC_OPT "Open sub-directories for fiscal year (CR = Y)"
$	IF DIREC_OPT .EQS. "" THEN DIREC_OPT := "Y"
$	IF DIREC_OPT .EQS. "Y" THEN GOTO OPEN_DIREC
$	IF DIREC_OPT .EQS. "N" THEN GOTO SKIP_OPEN
$	WRITE SYS$OUTPUT "     Please answer Y or N"
$	GOTO READ_DIREC
$!
$ OPEN_DIREC:
$	ON ERROR THEN GOTO ERR_OPEN_DIREC
$	WRITE SYS$OUTPUT ""
$	WRITE SYS$OUTPUT " Opening sub-directories for accounting storage."
$	WRITE SYS$OUTPUT ""
$	CREATE/DIREC/LOG [.FY81]
$	CREATE/DIREC/LOG [.FY81.MON01JAN]
$	CREATE/DIREC/LOG [.FY81.MON02FEB]
$	CREATE/DIREC/LOG [.FY81.MON03MAR]
$	CREATE/DIREC/LOG [.FY81.MON04APR]
$	CREATE/DIREC/LOG [.FY81.MON05MAY]
$	CREATE/DIREC/LOG [.FY81.MON06JUN]
$	CREATE/DIREC/LOG [.FY81.MON07JUL]
$	CREATE/DIREC/LOG [.FY81.MON08AUG]
$	CREATE/DIREC/LOG [.FY81.MON09SEP]
$	CREATE/DIREC/LOG [.FY81.MON10OCT]
$	CREATE/DIREC/LOG [.FY81.MON11NOV]
$	CREATE/DIREC/LOG [.FY81.MON12DEC]
$!
$ SKIP_OPEN:
$!
$ SET NOON
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT " COMPILE.COM now completed."
$ WRITE SYS$OUTPUT ""
$!
$ EXIT_ALL:
$	IF VER_MODE THEN $SET VERIFY
$	EXIT
$!
$!	Error Messages
$!
$ ERR_COMPILE:
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "%COMPILE-F-ERRCOMP: fatal error in compilation or"
$ WRITE SYS$OUTPUT "                    of ''SECTION' section"
$ GOTO EXIT_ALL
$!
$ ERR_PRINT_LIST:
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "%COMPILE-F-ERRPRINT: fatal error in printing listings."
$ GOTO EXIT_ALL
$!
$ ERR_OPEN_DIREC:
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "%COMPILE-F-ERROPEN: fatal error opening sub-directories."
$ GOTO EXIT_ALL
