C	NETMAP.FOR	V3.03	Stanley Rabinowitz	5-MAY-1981
C
	PROGRAM NETMAP
	INCLUDE 'NETMIN'
C
C	Since there is a blank column on the extreme right,
C	and a blank row at the bottom, we can get one extra row or
C	column in.
C
	DO 71 I=1,255
	CONNUM(I)=0
71	KNOWN(I)=.FALSE.
	DO 718 J=1,WHOLE
718	FREESP(J)=' '
	DO 717 JJ=1,6
	DO 717 J=1,MAXNOT
717	NONAME(J,JJ)=' '
	CALL START
	IF (MASTER) CALL GETMAS
	IF (DATMOD.EQ.1) CALL GETOLD
	IF (DATMOD.EQ.0) CALL GET
	IF (LIST) TYPE 720
720	FORMAT(' ')
C
C	If /SAVE was specified, then save the node information
C	in a file called NETMAP.DAT
C
	IF (SAVFLG) CALL SAVE
	IF (NOTEE) CALL NOTARY
C
C	Figure out which node we want to base our tree on.
C	This is our node unless the user typed a /BASE=node qualifier.
C	If, however, a location is specified, and no BASE was given
C	and we are not in that location, then pick the node at that
C	location with the most connections.
C
	IF (BASE(1).EQ.' ') GOTO 778
C
C	A base was specified by name; look up this name in the
C	list of valid names.
C
	DO 771 NODE=1,255
	DO 772 J=1,6
	IF (NAME(NODE,J).NE.BASE(J)) GOTO 771
772	CONTINUE
	BASED=NODE
	IF (KNOWN(BASED)) GOTO 779
	TYPE 7732
7732	FORMAT(' Base node is not reachable.')
	GOTO 778
771	CONTINUE
	TYPE 777, BASE
777	FORMAT(' Base node, ',6A1,', is not known.')
C
C	No base was specified, so we use our own node as base
C	if it's at the specified location.  Otherwise we hunt
C	around for a good node at that location.
C
778	BASED=OURNOD
	IF (WANTED(BASED)) GOTO 7731
C	IF (LOCSIZ.EQ.0) GOTO 7739
	DO 7734 NODE=1,255
C	DO 7735 J=1,LOCSIZ
C	IF (LOCNAM(J).NE.MASNAM(J,NODE)) GOTO 7734
C7735	CONTINUE
C	BASED=NODE
	IF (WANTED(NODE) .AND. KNOWN(NODE)) GOTO 7736
7734	CONTINUE
7739	TYPE 7733, (LOCNAM(J),J=1,LOCSIZ)
7733	FORMAT(' No such location as ',6A1)
	CALL EXIT
7736	BASED=NODE
7731	DO 773 J=1,6
773	BASE(J)=NAME(BASED,J)
779	IF (TREE) TYPE 780, BASE
780	FORMAT(/' Network Tree (based at ',6A1,'):'/)
C
C	Put terminal into graphics mode if necessary.
C
	IF (GIGI) GOTO 759
	IF (MODE) 759,750,751
C
C	Put terminal in special graphics mode using VT52 mode
C
751	TYPE 900, ESC,'F'
900	FORMAT(1X,2A1)
	GOTO 759
C
C	Put terminal in special graphics mode using VT100 mode
C
750	TYPE 901, ESC,'(','0'
901	FORMAT(1X,3A1)
759	CALL CLIMB
	IF (.NOT. MAP) GOTO 895
	CALL WEIGH
	IF (MAP .AND. DEVTYP.EQ.0) TYPE 930
930	FORMAT('1')
C
C	Try various attempts at generating a map with the initial
C	node being at all possible non-border squares.
C	Select the map found that contains the most nodes.
C
	MAXN=-1
	MINHOK=1000
	MAXR=0
	MAXC=0
C
C	Don't bother trying the initial square in the first or last row.
C
	IF (.NOT.EGUCAD) GOTO 931
C	CALL VSDRIV
C	CALL PLSTRT
C	CALL PLTSEL(8)
C	CALL GETSYM('NET$LIBRARY:NETMAP.SYM',IERR)
C	IF (IERR.NE.0) STOP 'Can''t find NET$LIBRARY:NETMAP.SYM'
931	IF (FAST) GOTO 932
	DO 979 R=2,GRIDR-1
	DO 979 C=1,GRIDC
	X=PLACE(R+1,C+1,.FALSE.,MAXN)
	IF (X.LT.MAXN .OR. (X.EQ.MAXN .AND. HOOKS.GT.MINHOK)) GOTO 979
	MAXN=X
	MAXR=R
	MAXC=C
	MINHOK=HOOKS
C
C	We can quit searching if we've found a map using all nodes
C	and didn't have to draw any hooks.
C
C	or if we've found a map that uses all locations in the grid
C	and didn't have to draw any hooks.
C
	IF ((MAXN.EQ.NODCNT .OR. MAXN.EQ.GRIDR*GRIDC) .AND. HOOKS.EQ.0)
     1	GOTO 980
979	CONTINUE
	GOTO 980
C
C	In /FAST algorithm, place base node in the center.
C
932	MAXR=(GRIDR+1)/2
	MAXC=(GRIDC+1)/2
980	CALL AUXINI
	X=PLACE(MAXR+1,MAXC+1,.TRUE.,MAXN)
C
C	Take terminal out of graphics mode
C
895	IF (GIGI) GOTO 896
	IF (MODE.EQ.0) TYPE 890, ESC,'(','B'
	IF (MODE.EQ.1) TYPE 890, ESC,'G'
890	FORMAT('+',$,3A1)
896	CONTINUE
C	IF (EGUCAD) CALL PLSTOP
C
C	Report on Ethernet nodes.
C
	IF (.NOT. ETHER) GOTO 949
	IF (ECOUNT.EQ.0) GOTO 940
	TYPE 941, ((NAME(ENODE(K),J),J=1,6), K=1,ECOUNT)
941	FORMAT(' Ethernet connections from nodes:',6(1X,6A1))
	GOTO 949
940	TYPE 942
942	FORMAT(' No connections to ETHERNET are up.')
949	CALL EXIT
	END
	SUBROUTINE GETOLD
	INCLUDE 'NETMIN/NOLIST'
C
C	The first section of NAME and KNOWN must be dimensioned at 256
C	since the number 256 is used as a sentinel to mark
C	the end of the valid node names in the input file.
C
C	Read our node number (OURNOD) and its initial location
C	and then the number of known node names (NUM)
C	from the data file.
C	The old data is either stored in NETMAP.DAT or is pointed
C	to by the logical name NETMAP.
C
74	OPEN(UNIT=2,NAME=OLDNAM,TYPE='OLD',ERR=99,READONLY)
	READ(2,200) OURNOD,DATIME
200	FORMAT(I3,1X,20A1)
C	IF (MASTER .AND. ONOD.NE.OURNOD) TYPE 801
C801	FORMAT(/' *** Our node number in NETMASTER not same as',
C     X	' in OLD data file.')
C
C	Now read the names of the known nodes.
C	These names are each 6 characters long.
C	They may have trailing blanks.
C
199	READ(2,201) N,(NAME(N,J),J=1,6),KNOWN(N)
201	FORMAT(I3,1X,6A1,1X,L1)
	IF (N.NE.256) GOTO 199
	CALL WANT
C
C	Calculate the number of non-space characters in each name.
C
	DO 210 I=1,255
	IF (NAME(I,1).EQ.' ') GOTO 210
	DO 211 J=1,6
	IF (NAME(I,J).EQ.' ') GOTO 212
211	CONTINUE
	J=7
212	NAMSIZ(I)=J-1
210	CONTINUE
	TYPE 100, (NAME(OURNOD,J),J=1,6),DATIME
100	FORMAT(/' Phase 3 Network Topology for Node ',6A1,
     1	'   on ',20A1)
C
C	Read in the known connections
C
300	READ(2,301,END=3999) A,B
301	FORMAT(I3,1X,I3)
C
C	We rule out any connections between unWANTED nodes.
C
	IF (.NOT.WANTED(A) .AND. .NOT.WANTED(B)) GOTO 300
C
C	Connect A to B
C
	IF (CONNUM(A).EQ.0) GOTO 302
	DO 303 I=1,CONNUM(A)
	IF (CONECT(A,I).EQ.B) GOTO 304
303	CONTINUE
302	IF (CONNUM(A).EQ.MAXFNG) GOTO 3021
	CONNUM(A)=CONNUM(A)+1
	CONECT(A,CONNUM(A))=B
	GOTO 304
3021	TYPE 3022, (NAME(A,J),J=1,6), MAXFNG
3022	FORMAT(' Node ',6A1,' has more than ',I3,' connections.')
C
C	Connect B to A
C
304	IF (CONNUM(B).EQ.0) GOTO 312
	DO 313 I=1,CONNUM(B)
	IF (CONECT(B,I).EQ.A) GOTO 314
313	CONTINUE
312	IF (CONNUM(B).EQ.MAXFNG) GOTO 3121
	CONNUM(B)=CONNUM(B)+1
	CONECT(B,CONNUM(B))=A
	GOTO 314
3121	TYPE 3022, (NAME(B,J),J=1,6), MAXFNG
314	GOTO 300
3999	CLOSE(UNIT=2)
	RETURN
99	DO 992 SIZ=1,256
	IF (OLDNAM(SIZ).EQ.0) GOTO 993
992	CONTINUE
993	SIZ=SIZ-1
	TYPE 991, (OLDNAM(J),J=1,SIZ)
991	FORMAT(' Old data file, ',<SIZ>A1,', not found or ',
     1	'not readable'/' or the logical name NETMAP points ',
     2	'to a bad file.')
	CALL EXIT
	END
	SUBROUTINE WANT
	INCLUDE 'NETMIN/NOLIST'
C
C	If we are using the master file, then mark nodes
C	at the wrong location NOT WANTED.
C	A node is WANTED if it is at the right location or
C	if it was not in the master file.
C
	WNTCNT=0
	DO 500 I=1,255
	IF (.NOT.MASTER .OR. LOCSIZ.EQ.0) GOTO 511
	IF (MASLEN(I).EQ.0) GOTO 511
	IF (LOCSIZ.GT.MASLEN(I)) GOTO 520
	DO 510 J=1,LOCSIZ
	IF (MASLOC(J,I).NE.LOCNAM(J)) GOTO 520
510	CONTINUE
511	WANTED(I)=.TRUE.
	WNTCNT=WNTCNT+1
C	TYPE 1234,(MASNAM(J,I),J=1,6),LOCNAM,(MASLOC(J,I),J=1,6),LOCSIZ
C1234	FORMAT(' Wanting: node ',6A1,' LOCNAM=',6A1,' NODE LOC=',6A1,I5)
	GOTO 500
520	WANTED(I)=.FALSE.
500	CONTINUE
	IF (WNTCNT.GT.0) RETURN
	TYPE 580, (LOCNAM(J),J=1,LOCSIZ)
580	FORMAT(' No such location as ',6A1)
	CALL EXIT
	END
	SUBROUTINE GETMAS
	INCLUDE 'NETMIN/NOLIST'
C
C	Read our node number (ONOD).
C
74	OPEN(UNIT=2,NAME='NET$LIBRARY:NETMASTER.DAT',
     X	TYPE='OLD',ERR=9905,READONLY)
9906	READ(2,200) ONOD
200	FORMAT(I3)
C
C	Now read the master information for the known nodes.
C	These names are each 6 characters long.
C	They may have trailing blanks.
C	The name is followed by the master location.
C	The list is terminated by a node number of 256.
C
199	READ(2,201,END=399) N,(MASNAM(J,N),J=1,6),(MASLOC(J,N),J=1,6)
201	FORMAT(I3,1X,6A1,1X,6A1)
	IF (N.NE.256) GOTO 199
C
C	Calculate the number of non-space characters in each name.
C
399	DO 210 I=1,255
	IF (MASNAM(1,I).EQ.' ') GOTO 210
	DO 211 J=1,6
	IF (MASNAM(J,I).EQ.' ') GOTO 212
211	CONTINUE
	J=7
212	MASNSZ(I)=J-1
210	CONTINUE
	DO 310 I=1,255
	IF (MASLOC(1,I).EQ.' ') GOTO 310
	DO 311 J=1,6
	IF (MASLOC(J,I).EQ.' ') GOTO 312
311	CONTINUE
	J=7
312	MASLEN(I)=J-1
310	CONTINUE
	CLOSE(UNIT=2)
	RETURN
C
C	Couldn't find NETMASTER in NET$LIBRARY, so try default area.
C
9905	OPEN(UNIT=2,NAME='NETMASTER.DAT',
     X	TYPE='OLD',ERR=99,READONLY)
	GOTO 9906
99	TYPE 991
991	FORMAT(/' Couldn''t read NET$LIBRARY:NETMASTER.DAT.')
	CALL EXIT
	END
	SUBROUTINE SAVE
	INCLUDE 'NETMIN/NOLIST'
	OPEN(UNIT=1,NAME=SAVNAM,CARRIAGECONTROL='LIST',TYPE='NEW')
C
C	Format of data file:
C
C	initial record:		our node number, date	I3,1X,20A1
C
C	name records:		node number, node name	I3,1X,A6,1X,L1
C				known
C
C	transition record:	256			I3
C
C	connectivity records:	node1-node2		I3,'-',I3
C
C	terminated by end-of-file.
C
	WRITE(1,5000) OURNOD,DATIME
5000	FORMAT(I3,1X,20A1)
	DO 5100 I=1,255
	IF (NAMSIZ(I).EQ.0) GOTO 5102
	WRITE(1,5001) I,(NAME(I,J),J=1,6),KNOWN(I)
5001	FORMAT(I3,1X,6A1,1X,L1)
	GOTO 5100
5102	IF (KNOWN(I)) WRITE(1,5001) I,(' ',J=1,6),KNOWN(I)
5100	CONTINUE
	WRITE(1,5001) 256
	DO 5200 I=1,255
	IF (CONNUM(I).EQ.0) GOTO 5200
	DO 5300 K=1,CONNUM(I)
	ADJ=CONECT(I,K)
	WRITE(1,5002) I,ADJ,(NAME(I,J),J=1,6),(NAME(ADJ,J),J=1,6)
5002	FORMAT(I3,'-',I3,1X,6A1,'-',6A1)
5300	CONTINUE
5200	CONTINUE
	CLOSE(UNIT=1)
	RETURN
	END
	SUBROUTINE CLIMB
	INCLUDE 'NETMIN/NOLIST'
	DIMENSION LEVNOD(32,31),LEVNUM(32),LEVIDX(32)
	DIMENSION PARENT(32)
	LOGICAL*1 DRAWN(255)
	LOGICAL NDNOD
	PARAMETER LINSIZ=20
	LOGICAL*1 LINBFR(9,LINSIZ), LB(LINSIZ*9)
	EQUIVALENCE(LINBFR,LB)
C
C	Do a tree walk to print the tree.
C
	DO 70 I=1,255
70	DRAWN(255)=.FALSE.
	DO 71 J=1,LINSIZ*9
71	LB(J)=' '
C
C	Calculate the depth of each node and count them.
C
	CALL GAUGE
	LEVNOD(1,1)=BASED
	LEVNUM(1)=1
	LEVIDX(1)=1
	PARENT(1)=0
	LEVEL=1
	NODE=BASED
	GOTO 21
C
C	Is this the last node at this level?
C
3	DO 40 SIZ=LINSIZ*9,1,-1
	IF (LB(SIZ).NE.' ') GOTO 41
40	CONTINUE
41	IF (TREE) TYPE 100, (LB(J),J=1,SIZ)
100	FORMAT(1X,132A1)
	DO 42 J=1,SIZ
42	LB(J)=' '
32	IF (LEVIDX(LEVEL).LE.LEVNUM(LEVEL)) GOTO 4
C
C	Yes, go back a level
C
	LEVEL=LEVEL-1
	IF (LEVEL.EQ.0) RETURN
	GOTO 32
C
C	Print a new node at this level
C
4	DO 43 J=1,6
43	LINBFR(J,1)=' '
C
C	Print preceding levels
C
	IF (LEVEL.EQ.2) GOTO 20
	DO 10 LVL=2,LEVEL-1
	IF (LEVIDX(LVL).GT.LEVNUM(LVL)) GOTO 12
C
C	Kern a childless node into this spot if one is available.
C
	ENDSON=LEVNOD(LVL,LEVNUM(LVL))
	IF (CONNUM(ENDSON).NE.1) GOTO 14
C
C	Move the end son to be the next son
C	and move everyone else down.
C
	IF (LEVIDX(LVL).EQ.LEVNUM(LVL)) GOTO 19
	DO 192 I=LEVNUM(LVL)-1,LEVIDX(LVL),-1
192	LEVNOD(LVL,I+1)=LEVNOD(LVL,I)
	LEVNOD(LVL,LEVIDX(LVL))=ENDSON
	TYPCON=INTCON
191	LEVIDX(LVL)=LEVIDX(LVL)+1
	DO 18 J=1,6
18	LINBFR(J,LVL)=NAME(ENDSON,J)
	GOTO 13
19	TYPCON=ENDCON
	GOTO 191
C
C	No childless node is available.
C
14	TYPCON=BARCON
	GOTO 13
12	TYPCON=NONCON
13	DO 44 J=1,3
44	LINBFR(6+J,LVL-1)=CONXTR(J,TYPCON)
10	CONTINUE
C
C	Print current level
C
20	TYPCON=INTCON
	IF (LEVIDX(LEVEL).EQ.LEVNUM(LEVEL)) TYPCON=ENDCON
	IF (LEVIDX(LEVEL).EQ.1) 	    TYPCON=TOPCON
	IF (LEVNUM(LEVEL).EQ.1)		    TYPCON=STRCON
	NODE=LEVNOD(LEVEL,LEVIDX(LEVEL))
	DO 46 J=1,3
46	LINBFR(6+J,LEVEL-1)=CONXTR(J,TYPCON)
21	LEVIDX(LEVEL)=LEVIDX(LEVEL)+1
	NS=NAMSIZ(NODE)
	IF (NS.GT.6) TYPE 1234,NS,NODE,LEVEL
1234	FORMAT(' NAMESIZE=',I8,' NODE=',I5,'  LEVEL=',I5)
	IF (NS.GT.6) PAUSE 1234
	DO 47 J=1,NS
47	LINBFR(J,LEVEL)=NAME(NODE,J)
C
C	This is an end-node if it either has no descendents
C	or if it was seen before at an equal or greater level
C	(but not used).
C
	NDNOD=(DEPTH(NODE).LT.LEVEL).OR.DRAWN(NODE)
	IF (NS.NE.6 .AND. .NOT.NDNOD .AND.
     1	(CONNUM(NODE).GT.1 .OR. LEVEL.EQ.1)) GOTO 48
	GOTO 50
48	DO 49 J=NS+1,6
49	LINBFR(J,LEVEL)=DASH
50	IF (NDNOD) LINBFR(NS+1,LEVEL)='*'
	IF (NDNOD) GOTO 3
	DRAWN(NODE)=.TRUE.
C
C	Does this node have any descendents?
C
	IF (CONNUM(NODE).EQ.1 .AND. LEVEL.NE.1) GOTO 3
C
C	Rare case: 0 connections if all physical links down.
C
	IF (CONNUM(NODE).EQ.0) GOTO 3
C
C	Yes, advance a level
C
	LEVEL=LEVEL+1
C
C	Compute the number of sons at this level.
C	Do not count the parent.
C	Create a list of the sons, putting mature sons (ones with
C	children of their own) first.
C
	LEVNUM(LEVEL)=CONNUM(NODE)-1
	IF (LEVEL.EQ.2) LEVNUM(LEVEL)=LEVNUM(LEVEL)+1
	PARENT(LEVEL)=NODE
	K=0
	DO 31 I=1,CONNUM(NODE)
	SON=CONECT(NODE,I)
	IF (SON.EQ.PARENT(LEVEL-1)) GOTO 31
	K=K+1
	LEVNOD(LEVEL,K)=SON
C
C	If this new son is mature, switch him with the first childless son.
C
	IF (CONNUM(SON).EQ.1 .OR. K.EQ.1) GOTO 31
	DO 35 J=1,K-1
	SIBLING=LEVNOD(LEVEL,J)
	IF (CONNUM(SIBLING).NE.1) GOTO 35
	LEVNOD(LEVEL,K)=SIBLING
	LEVNOD(LEVEL,J)=SON
	GOTO 31
35	CONTINUE
31	CONTINUE
	LEVIDX(LEVEL)=1
	GOTO 20
	END
	FUNCTION PLACE(STARTR,STARTC,FLAG,NODKNT)
	INCLUDE 'NETMIN/NOLIST'
	LOGICAL FLAG
	DIMENSION ITEM(32,255),ITMCNT(32)
	DIMENSION PLACEE(32)
	DIMENSION RBEST(25),CBEST(25)
	LOGICAL*1 BLOCKD(25,25)
C
C	have room to remember 9 paths that couldn't be drawn in to a node.
C
C
C	Node n placed in rectangular box with top left square at
C	(RPLACE,CPLACE)	and having a horizontal width of XTENT boxes
C	and a vertical depth of HEIGHT boxes.
C	XTENT=0 means that the node has not yet been placed in the grid.
C
	DO 2 NODE=1,255
	RPLACE(NODE)=0
	CPLACE(NODE)=0
	NOPCNT(NODE)=0
	HEIGHT(NODE)=0
2	XTENT(NODE)=0
	CONCNT=0
	LOOPCT=0
C
C	Initialize the grid.
C	Surround it by occupied elements and make
C	all the other elements 0 (unoccupied).
C
	DO 1000 R=2,GRIDR+2
	DO 1000 C=2,GRIDC+2
1000	GRID(R,C)=0
	DO 1001 C=1,GRIDC+2
	GRID(1,C)=-1
1001	GRID(GRIDR+2,C)=-1
	DO 1002 R=1,GRIDR+2
	GRID(R,1)=-1
1002	GRID(R,GRIDC+2)=-1
	DO 1003 I=1,25
	DO 1003 J=1,25
1003	BLOCKD(I,J)=.FALSE.
C
C	Place the base node at the starting position.
C
909	DO 951 I=1,32
951	ITMCNT(I)=0
	LEVMAX=20
	RPLACE(BASED)=STARTR
	CPLACE(BASED)=STARTC
	XTENT(BASED)=1
	HEIGHT(BASED)=1
	PLACE=1
	GRID(STARTR,STARTC)=BASED
	IF (DEBUG.AND.MAP)TYPE 950,(NAME(BASED,J),J=1,6),STARTR,STARTC
950	FORMAT(' PUTTING ',6A1,' AT ROW ',I2,' COLUMN ',I3)
	ITMCNT(1)=1
	ITEM(1,1)=BASED
C
C	Place the next guy in the item list on the grid
C
	DO 1999 LEVEL=1,LEVMAX
C
C	Try to place the items surrounding those at level LEVEL on the grid.
C	While we're at it, form the nodes for the next level
C
	IF (ITMCNT(LEVEL).EQ.0) GOTO 1999
	DO 1899 INDEX=1,ITMCNT(LEVEL)
	CENODE=ITEM(LEVEL,INDEX)
	IF (CONNUM(CENODE).LT.1) GOTO 1899
	DO 1700 P=1,32
1700	PLACEE(P)=0
	P=0
	DO 1799 K=1,CONNUM(CENODE)
	NODE=CONECT(CENODE,K)
C
C	If ENDNOD is false then
C	skip nodes that are end nodes and WANTED
C	but do not skip the base or our own node.
C	
	IF (ENDNOD) GOTO 1717
	IF (NODE.EQ.OURNOD .OR. NODE.EQ.BASED) GOTO 1717
	IF (CONNUM(NODE).EQ.1) GOTO 1799
1717	IF (XTENT(NODE).NE.0) GOTO 1798
	P=P+1
C
C	Sort the nodes to be placed into array PLACEE
C	in order of decreasing WEIGHT.
C
	PLACEE(P)=NODE
	IF (P.EQ.1) GOTO 1799
	DO 1770 PX=1,P-1
	NOD=PLACEE(PX)
	IF (WEIGHT(NOD).GE.WEIGHT(NODE)) GOTO 1770
	DO 1771 QX=P-1,PX,-1
	PLACEE(QX+1)=PLACEE(QX)
1771	CONTINUE
	PLACEE(PX)=NODE
	GOTO 1799
1770	CONTINUE
	GOTO 1799
C
C	Came back to a node that has already been placed.
C	If it is our father, then the connection has already been
C	drawn in.  Otherwise, it represents a loop.
C	Not good enough to see if it has a smaller depth;
C	so we will check all the connections to see if we have
C	made it yet.
C
1798	DO 1797 T=1,CONCNT
	IF (CONS(T,1).EQ.NODE .AND. CONS(T,2).EQ.CENODE) GOTO 1799
	IF (CONS(T,2).EQ.NODE .AND. CONS(T,1).EQ.CENODE) GOTO 1799
1797	CONTINUE
C
C	Make sure we don't already have it in the loop closer list.
C
	IF (LOOPCT.EQ.0) GOTO 1795
	DO 1796 T=1,LOOPCT
	IF (LOOP(T,1).EQ.NODE .AND. LOOP(T,2).EQ.CENODE) GOTO 1799
	IF (LOOP(T,2).EQ.NODE .AND. LOOP(T,1).EQ.CENODE) GOTO 1799
1796	CONTINUE
1795	IF (LOOPCT.EQ.MAXLOP) GOTO 17951
	LOOPCT=LOOPCT+1
	LOOP(LOOPCT,1)=CENODE
	LOOP(LOOPCT,2)=NODE
	GOTO 17953
17951	TYPE 17952, MAXLOP
17952	FORMAT(' Warning: more than ',I3,' loops.')
	GOTO 1799
C
C	Now it's possible that we saw the other end of the path first
C	and placed this node in his inaccessible list.
C	So now we must remove it.
C
17953	DO 1791 T=1,NOPCNT(NODE)
	IF (NOPATH(NODE,T).EQ.CENODE) GOTO 1792
1791	CONTINUE
	GOTO 1799
1792	NOPATH(NODE,T)=NOPATH(NODE,NOPCNT(NODE))
	NOPCNT(NODE)=NOPCNT(NODE)-1
1799	CONTINUE
	IF (P.EQ.0) GOTO 1899
C
C	See if we must extend CENODE (the first time through).
C	We have P nodes that must be placed next to it.
C	How many free squares have we?
C
	DO 8765 PINDEX=1,P
C
C	Find the empty squares around CENODE
C	and put them in RBEST,CBEST.
C
30	BCOUNT=0
	R=RPLACE(CENODE)
	C=CPLACE(CENODE)
	XT=XTENT(CENODE)
	HT=HEIGHT(CENODE)
	DO 40 RR=R-1,R+HT
	DO 40 CC=C-1,C+XT
	IF (GRID(RR,CC).NE.0) GOTO 40
C
C	Don't allow criss crosses.
C	We mark the upper left box of a quadruple when the diagonal
C	crossing is blocked.  For example,  if B is connected to D,
C	then we mark the "center point" as being a point of blockage.
C	This blockage is noted at A.
C
C			A  B			A  B
C			  /			 \
C			 /			  \
C			C  D			C  D
C
C
	IF (CC.EQ.C-1 .AND.RR.EQ.R-1 .AND.BLOCKD(RR  ,CC  )) GOTO 40
	IF (CC.EQ.C-1 .AND.RR.EQ.R+HT.AND.BLOCKD(RR-1,CC  )) GOTO 40
	IF (CC.EQ.C+XT.AND.RR.EQ.R-1 .AND.BLOCKD(RR  ,CC-1)) GOTO 40
	IF (CC.EQ.C+XT.AND.RR.EQ.R+HT.AND.BLOCKD(RR-1,CC-1)) GOTO 40
	BCOUNT=BCOUNT+1
	RBEST(BCOUNT)=RR
	CBEST(BCOUNT)=CC
40	CONTINUE
	IF (PINDEX.NE.1) GOTO 70
C
C	If node has many neighbors, then we should extend a little
C	bit more than necessary.  If it has n sons, we should have
C	room for n+((n-1)/3) boxes.
C
C	IF (BCOUNT.GE.P+(P-1)/3) GOTO 70
	IF (BCOUNT.GE.P) GOTO 70
C
C	Need to extend. Try to extend to the right.
C
	DO 651 J=R,R+HT-1
	IF (GRID(J,C+XT).NE.0) GOTO 69
651	CONTINUE
	DO 652 J=R,R+HT-1
652	GRID(J,C+XT)=-1
	XTENT(CENODE)=XTENT(CENODE)+1
	GOTO 30
C
C	Couldn't extend to the right, try to extend to the left.
C
69	DO 691 J=R,R+HT-1
	IF (GRID(J,C-1).NE.0) GOTO 68
691	CONTINUE
	DO 692 J=R,R+HT-1
692	GRID(J,C-1)=-1
	GRID(R,C-1)=GRID(R,C)
	GRID(R,C)=-1
	XTENT(CENODE)=XTENT(CENODE)+1
	CPLACE(CENODE)=C-1
	GOTO 30
C
C	Couldn't extend horizontally, try to extend vertically upward.
C
68	DO 681 J=C,C+XT-1
	IF (GRID(R-1,J).NE.0) GOTO 67
681	CONTINUE
	DO 682 J=C,C+XT-1
682	GRID(R-1,J)=-1
	GRID(R-1,C)=GRID(R,C)
	GRID(R,C)=-1
	HEIGHT(CENODE)=HEIGHT(CENODE)+1
	RPLACE(CENODE)=R-1
	GOTO 30
C
C	Couldn't extend upward, try to extend downward.
C
67	DO 671 J=C,C+XT-1
	IF (GRID(R+HT,J).NE.0) GOTO 70
671	CONTINUE
	DO 672 J=C,C+XT-1
672	GRID(R+HT,J)=-1
	HEIGHT(CENODE)=HEIGHT(CENODE)+1
	GOTO 30
C	***** MAKE A SUBROUTINE
C
C	Couldn't extend in any direction.
C
70	IF (BCOUNT.NE.0) GOTO 1888
C
C	Couldn't place some nodes.
C	Save this information.
C
	NOPCNT(CENODE)=MIN(P-PINDEX+1,MAXNOP)
	DO 1887 K=1,NOPCNT(CENODE)
1887	NOPATH(CENODE,K)=PLACEE(PINDEX+K-1)
	GOTO 1899
1888	HIGH=-1
	DO 2000 B=1,BCOUNT
	RX=RBEST(B)
	CX=CBEST(B)
	ADJCNT=0
	DO 2001 RY=RX-1,RX+1
	DO 2001 CY=CX-1,CX+1
	IF (GRID(RY,CY).NE.0) GOTO 2001
	IF (RY.EQ.RX .AND. CY.EQ.CX) GOTO 2001
	ADJCNT=ADJCNT+20
		DO 2140 RZ=RY-1,RY+1
		DO 2140 CZ=CY-1,CY+1
		IF (GRID(RZ,CZ).NE.0) GOTO 2140
		ADJCNT=ADJCNT+1
2140		CONTINUE
C
C	Give a slight bonus for making an orthogonal connection.
C	If the node to be placed is an end-node, give a big bonus.
C
	IF (.NOT. LINEAR) GOTO 2001
	ORTHOG=19
	IF (CONNUM(PLACEE(PINDEX)).EQ.1) ORTHOG=81
	IF (RX.EQ.R .OR. CX.EQ.C) ADJCNT=ADJCNT+ORTHOG
2001	CONTINUE
	IF (ADJCNT.LE.HIGH) GOTO 2000
	HIGH=ADJCNT
	HIGHB=B
2000	CONTINUE
C
C	Place the first node at the best square found.
C
	NODE=PLACEE(PINDEX)
	ITMCNT(LEVEL+1)=ITMCNT(LEVEL+1)+1
	ITEM(LEVEL+1,ITMCNT(LEVEL+1))=NODE
C
C	PLACE NODE
C
	RPLACE(NODE)=RBEST(HIGHB)
	CPLACE(NODE)=CBEST(HIGHB)
	GRID(RPLACE(NODE),CPLACE(NODE))=NODE
	XTENT(NODE)=1
	HEIGHT(NODE)=1
	PLACE=PLACE+1
	CONCNT=CONCNT+1
	CONS(CONCNT,1)=NODE
	CONS(CONCNT,2)=CENODE
C
C	If this is a diagonal connection, then we must mark
C	the upper left corner box to indicate a diagonal blockage.
C
	RP=RPLACE(NODE)
	CP=CPLACE(NODE)
	IF (RP.EQ.R-1  .AND. CP.EQ.C-1 ) BLOCKD(RP  ,CP  )=.TRUE.
	IF (RP.EQ.R+HT .AND. CP.EQ.C-1 ) BLOCKD(RP-1,CP  )=.TRUE.
	IF (RP.EQ.R-1  .AND. CP.EQ.C+XT) BLOCKD(RP  ,CP-1)=.TRUE.
	IF (RP.EQ.R+HT .AND. CP.EQ.C+XT) BLOCKD(RP-1,CP-1)=.TRUE.
C	IF (BCOUNT.EQ.1) GOTO 1899
8765	CONTINUE
1899	CONTINUE
1999	CONTINUE
	IF (.NOT.FLAG) GOTO 894
	IF (PLACE.EQ.NODCNT) TYPE 892, NODCNT, DATIME
	IF (PLACE.NE.NODCNT) TYPE 891, PLACE, NODCNT, DATIME
891	FORMAT(//' NETWORK MAP (',I3,' OUT OF ',I3,' NODES):    ',
     1	20A1/)
892	FORMAT(//' NETWORK MAP (',I3,' NODES):    ',20A1/)
C	TYPE 893
C893	FORMAT()
894	IF (PLACE.LT.NODKNT) RETURN
	CALL DRAW(FLAG)
	RETURN
	END
	SUBROUTINE WEIGH
	INCLUDE 'NETMIN/NOLIST'
	DIMENSION WTOTAL(255),WINDEX(255),WNODE(255)
	LOGICAL*1 USED(255)
	EQUIVALENCE (WTOTAL,FREESP(1))
	EQUIVALENCE (WINDEX,FREESP(512))
	EQUIVALENCE (WNODE ,FREESP(1024))
	EQUIVALENCE (USED  ,FREESP(1536))
C
C	Assign weights to each node
C
	DO 1200 I=1,255
	USED(I)=.FALSE.
1200	WEIGHT(I)=0
	LEVEL=1
	WNODE(1)=BASED
	WINDEX(1)=1
	WTOTAL(1)=0
	USED(BASED)=.TRUE.
C
C	Are we done at this level?
C
1220	NODE=WNODE(LEVEL)
	IF (WINDEX(LEVEL).GT.CONNUM(NODE)) GOTO 1211
	SON=CONECT(NODE,WINDEX(LEVEL))
	IF (USED(SON)) GOTO 1201
	IF (CONNUM(SON).NE.1) GOTO 1210
	WTOTAL(LEVEL)=WTOTAL(LEVEL)+1
1201	WINDEX(LEVEL)=WINDEX(LEVEL)+1
	GOTO 1220
C
C	yes, back up a level
C
1211	WEIGHT(NODE)=WTOTAL(LEVEL)
	USED(NODE)=.FALSE.
	LEVEL=LEVEL-1
	IF (LEVEL.EQ.0) RETURN
	WTOTAL(LEVEL)=WTOTAL(LEVEL)+WTOTAL(LEVEL+1)
	GOTO 1201
C
C	no, go down a level
C
1210	LEVEL=LEVEL+1
	USED(NODE)=.TRUE.
	WNODE(LEVEL)=SON
	WINDEX(LEVEL)=1
	WTOTAL(LEVEL)=CONNUM(SON)-1
	GOTO 1220
	END
	SUBROUTINE GAUGE
	INCLUDE 'NETMIN/NOLIST'
C
C	Figure out the depth of each node.
C
	DO 1200 I=1,255
1200	DEPTH(I)=0
	NODCNT=1
	DEPTH(BASED)=1
	DO 2 LEVEL=1,50
	LEVCNT=0
	DO 3 NODE=1,255
C
C	Go to each node in list and find those at the current
C	depth.  Mark each new son as having
C	a depth one greater than the depth of its parent.
C
	IF (DEPTH(NODE).NE.LEVEL) GOTO 3
	LEVCNT=LEVCNT+1
	MAX=CONNUM(NODE)
	IF (MAX.EQ.0) GOTO 3
	DO 4 K=1,MAX
	SON=CONECT(NODE,K)
	IF (DEPTH(SON).NE.0) GOTO 4
	NODCNT=NODCNT+1
	DEPTH(SON)=LEVEL+1
4	CONTINUE
3	CONTINUE
	IF (LEVCNT.EQ.0) RETURN
2	CONTINUE
	RETURN
	END
	SUBROUTINE NOTARY
	INCLUDE 'NETMIN/NOLIST'
	INTEGER*4 GENDER,NOUN,PRNOUN
C
C	Note types:
C
C	1	We had no name for node but someone else had a name.
C	2	We had    name for node but someone had a different name.
C
C	NOTYPE(n,1)	Type of note n.
C	NOTYPE(n,2)	Node number of node whose name is wrong.
C	NOTYPE(n,3)	Node number of node giving us a different name.
C
	IF (NOTKNT.EQ.0) RETURN
	TYPE 100
100	FORMAT(/' Notes:'/)
	DO 2 N=1,NOTKNT
	TYPE=NOTYPE(N,1)
	NODE=NOTYPE(N,2)
	TALE=NOTYPE(N,3)
	GENDER='his'
	NOUN='he'
	PRNOUN='him'
	IF (NODE) GENDER='her'
	IF (NODE) NOUN='she'
	IF (NODE) PRNOUN='her'
	GOTO (10,20), TYPE
C
C	We had no name.
C
10	IF (NODE.EQ.TALE) GOTO 15
C
C	Someone else gave us a name.
C
	TYPE 101, NODE,(NAME(TALE,J),J=1,6),GENDER,(NONAME(N,J),J=1,6)
101	FORMAT(' We had no name for node ',I3,' but ',6A1,
     1	' thought ',A3,' name was ',6A1,'.')
	GOTO 2
C
C	Remote node gave us his/her name.
C
15	TYPE 102, NODE,NOUN,PRNOUN,(NONAME(N,J),J=1,6)
102	FORMAT(' We had no name for node ',I3,' but  ',A3,
     1	'   calls  ',A3,'self     ',6A1,'.')
	GOTO 2
C
C	We had a different name.
C
20	IF (NODE.EQ.TALE) GOTO 25
C
C	Someone else gave us a name.
C
	TYPE 103, NODE,(NAME(NODE,J),J=1,6),
     1	(NAME(TALE,J),J=1,6),GENDER,(NONAME(N,J),J=1,6)
103	FORMAT(' We call node  ',I3,'  ',6A1,',  but ',6A1,
     1	' thought ',A3,' name was ',6A1,'.')
	GOTO 2
C
C	Remote node gave us his/her name.
C
25	TYPE 104, NODE,(NAME(NODE,J),J=1,6),
     1	NOUN,PRNOUN,(NONAME(N,J),J=1,6)
104	FORMAT(' We call node  ',I3,'  ',6A1,',  but  ',A3,
     1	'   refers to ',A3,'self as ',6A1,'.')
	GOTO 2
2	CONTINUE
	TYPE 150
150	FORMAT(' ')
	RETURN
	END
	SUBROUTINE SNAKE(NODE1,NODE2,FLAG)
	INCLUDE 'NETMIN/NOLIST'
	INTEGER*2 XBOARD(MAXH,MAXW)
	INTEGER*2 RPATH(1000),CPATH(1000)
	LOGICAL*1 MAGIC(5,5),TLEFT,TRIGHT
	PARAMETER SNMAX=700
	INTEGER*2 SNRLOC(SNMAX),SNCLOC(SNMAX),TNRLOC(SNMAX),TNCLOC(SNMAX)
	MAGIC(1,1)=VB
	MAGIC(1,2)=UR
	MAGIC(1,4)=UL
	MAGIC(2,1)=LL
	MAGIC(2,2)=HB
	MAGIC(2,5)=UL
	MAGIC(4,1)=LR
	MAGIC(4,4)=HB
	MAGIC(4,5)=UR
	MAGIC(5,2)=LR
	MAGIC(5,4)=LL
	MAGIC(5,5)=VB
C
C	Copy BOARD to XBOARD
C
	DO 2 R=1,PAGSIZ
	DO 2 C=1,WIDTH
2	XBOARD(R,C)=BOARD(R,C)
C
C	Mark accessible border of NODE1 with a count of 1000.
C
	SNSIZ=0
	R=RPLACE(NODE1)-1
	C=CPLACE(NODE1)-1
	XT=XTENT(NODE1)
	HT=HEIGHT(NODE1)
	XR=GRIDH*(R-1)+1+TMARG
	XC=GRIDW*(C-1)+1+LMARG
	DO 3 J=XC+1,XC+GRIDW*XT-2-HORSP
	IF (XBOARD(XR,J).NE.HB) GOTO 31
	XBOARD(XR,J)=1000
	SNSIZ=SNSIZ+1
	SNRLOC(SNSIZ)=XR
	SNCLOC(SNSIZ)=J
31	IF (XBOARD(XR+GRIDH*HT-1-VERSP,J).NE.HB) GOTO 3
	XBOARD(XR+GRIDH*HT-1-VERSP,J)=1000
	SNSIZ=SNSIZ+1
	SNRLOC(SNSIZ)=XR+GRIDH*HT-1-VERSP
	SNCLOC(SNSIZ)=J
3	CONTINUE
	DO 4 J=XR+1,XR+GRIDH*HT-2-VERSP
	IF (XBOARD(J,XC).NE.VB) GOTO 41
	XBOARD(J,XC)=1000
	SNSIZ=SNSIZ+1
	SNRLOC(SNSIZ)=J
	SNCLOC(SNSIZ)=XC
41	IF (XBOARD(J,XC+GRIDW*XT-1-HORSP).NE.VB) GOTO 4
	XBOARD(J,XC+GRIDW*XT-1-HORSP)=1000
	SNSIZ=SNSIZ+1
	SNRLOC(SNSIZ)=J
	SNCLOC(SNSIZ)=XC+GRIDW*XT-1-HORSP
4	CONTINUE
C
C	Mark accessible border of NODE2 with a count of -1
C
	R=RPLACE(NODE2)-1
	C=CPLACE(NODE2)-1
	XT=XTENT(NODE2)
	HT=HEIGHT(NODE2)
	XR=GRIDH*(R-1)+1+TMARG
	XC=GRIDW*(C-1)+1+LMARG
	DO 5 J=XC+1,XC+GRIDW*XT-2-HORSP
	IF (XBOARD(XR,J).EQ.HB) XBOARD(XR,J)=-1
	IF (XBOARD(XR+GRIDH*HT-1-VERSP,J).EQ.HB)
     X	XBOARD(XR+GRIDH*HT-1-VERSP,J)=-1
5	CONTINUE
	DO 6 J=XR+1,XR+GRIDH*HT-2-VERSP
	IF (XBOARD(J,XC).EQ.VB) XBOARD(J,XC)=-1
	IF (XBOARD(J,XC+GRIDW*XT-1-HORSP).EQ.VB)
     X	XBOARD(J,XC+GRIDW*XT-1-HORSP)=-1
6	CONTINUE
C
C	Now fan out.
C
	RM=PAGSIZ
	CM=WIDTH
	DO 99 DEPT=1000,30000
	SNSIZE=SNSIZ
	DO 995 J=1,SNSIZE
	TNCLOC(J)=SNCLOC(J)
995	TNRLOC(J)=SNRLOC(J)
	SNSIZ=0
	DO 7 SIZ=1,SNSIZE
	R=TNRLOC(SIZ)
	C=TNCLOC(SIZ)
	IF (R.EQ.1) GOTO 51
	IF (XBOARD(R-1,C).NE.32) GOTO 51
	XBOARD(R-1,C)=DEPT+1
	SNSIZ=MIN(SNSIZ+1,SNMAX)
	SNRLOC(SNSIZ)=R-1
	SNCLOC(SNSIZ)=C
51	IF (R.EQ.RM) GOTO 52
	IF (XBOARD(R+1,C).NE.32) GOTO 52
	XBOARD(R+1,C)=DEPT+1
	SNSIZ=MIN(SNSIZ+1,SNMAX)
	SNRLOC(SNSIZ)=R+1
	SNCLOC(SNSIZ)=C
52	IF (C.EQ.1) GOTO 53
	IF (XBOARD(R,C-1).NE.32) GOTO 53
	XBOARD(R,C-1)=DEPT+1
	SNSIZ=MIN(SNSIZ+1,SNMAX)
	SNRLOC(SNSIZ)=R
	SNCLOC(SNSIZ)=C-1
53	IF (C.EQ.CM) GOTO 54
	IF (XBOARD(R,C+1).NE.32) GOTO 54
	XBOARD(R,C+1)=DEPT+1
	SNSIZ=MIN(SNSIZ+1,SNMAX)
	SNRLOC(SNSIZ)=R
	SNCLOC(SNSIZ)=C+1
54	IF (R.EQ.1) GOTO 55
	IF (XBOARD(R-1,C).EQ.-1) GOTO 90
55	IF (R.EQ.RM) GOTO 56
	IF (XBOARD(R+1,C).EQ.-1) GOTO 91
56	IF (C.EQ.1) GOTO 57
	IF (XBOARD(R,C-1).EQ.-1) GOTO 92
57	IF (C.EQ.CM) GOTO 7
	IF (XBOARD(R,C+1).EQ.-1) GOTO 93
7	CONTINUE
	IF (SNSIZ.EQ.0) GOTO 130
99	CONTINUE
C
C	Couldn't close the loop, so add nodes to list of those
C	with paths missing.
C
130	PTHLEN=0
	IF (.NOT.FLAG) GOTO 120
	NOPCNT(NODE1)=MIN(NOPCNT(NODE1)+1,MAXNOP)
	NOPATH(NODE1,NOPCNT(NODE1))=NODE2
	NOPCNT(NODE2)=MIN(NOPCNT(NODE2)+1,MAXNOP)
	NOPATH(NODE2,NOPCNT(NODE2))=NODE1
	GOTO 120
90	FINALR=R-1
	FINALC=C
	GOTO 80
91	FINALR=R+1
	FINALC=C
	GOTO 80
92	FINALR=R
	FINALC=C-1
	GOTO 80
93	FINALR=R
	FINALC=C+1
C
C	Construct the path.
C
80	PTHLEN=DEPT-1000+2
	RPATH(PTHLEN)=FINALR
	CPATH(PTHLEN)=FINALC
	DO 70 D=DEPT,1000,-1
	OLDR=RPATH(D+2-1000)
	OLDC=CPATH(D+2-1000)
C
C	Try to continue in the same direction.
C
	IF (D.EQ.DEPT) GOTO 801
	QR=2*OLDR-RPATH(D+3-1000)
	QC=2*OLDC-CPATH(D+3-1000)
	IF (QR.LT.1 .OR. QR.GT.RM .OR. QC.LT.1 .OR. QC.GT.CM) GOTO 801
	IF (XBOARD(QR,QC).EQ.D) GOTO 75
801	QR=OLDR-1
	QC=OLDC
	IF (QR.GT.0  .AND. XBOARD(QR,QC).EQ.D) GOTO 75
	QR=OLDR+1
	QC=OLDC
	IF (QR.LE.RM .AND. XBOARD(QR,QC).EQ.D) GOTO 75
	QR=OLDR
	QC=OLDC-1
	IF (QC.GT.0  .AND. XBOARD(QR,QC).EQ.D) GOTO 75
	QR=OLDR
	QC=OLDC+1
	IF (QC.LE.CM .AND. XBOARD(QR,QC).EQ.D) GOTO 75
	TYPE 1111, OLDR,OLDC,D
1111	FORMAT(' INTERNAL ERROR AT ',2I5,' D=',I8)
	PTHLEN=0
	GOTO 120
75	RPATH(D+1-1000)=QR
	CPATH(D+1-1000)=QC
70	CONTINUE
120	CONTINUE
C
C	Draw the extended path (snake) closing the loop.
C
	IF (PTHLEN.EQ.0) GOTO 131
C	CALL AUXEND
	DO 300 P=2,PTHLEN-1
	X1=CPATH(P)-CPATH(P-1)+2*(RPATH(P)-RPATH(P-1))+3
	X2=CPATH(P+1)-CPATH(P)+2*(RPATH(P+1)-RPATH(P))+3
	RP=RPATH(P)
	CP=CPATH(P)
	BOARD(RP,CP)=MAGIC(X1,X2)
	IF (.NOT. FLAG) GOTO 300
C	TYPE 1234, RP,CP
C1234	FORMAT(1X,2I5)
C	GOTO 300
	IF (MAGIC(X1,X2).EQ.HB) CALL AUXHB(RP,CP)
	IF (MAGIC(X1,X2).EQ.VB) CALL AUXVB(RP,CP)
	IF (MAGIC(X1,X2).EQ.UR) CALL AUXUR(RP,CP)
	IF (MAGIC(X1,X2).EQ.UL) CALL AUXUL(RP,CP)
	IF (MAGIC(X1,X2).EQ.LL) CALL AUXLL(RP,CP)
	IF (MAGIC(X1,X2).EQ.LR) CALL AUXLR(RP,CP)
300	CONTINUE
C
C	Handle the endpoints of the snake specially.
C
	TLEFT=TL
	TRIGHT=TR
	IF (TLEFT .EQ.'|') TLEFT ='+'
	IF (TRIGHT.EQ.'|') TRIGHT='+'
	IF (RPATH(1).LT.RPATH(2) .AND. CPATH(1).EQ.CPATH(2)) T=TD
	IF (RPATH(1).GT.RPATH(2) .AND. CPATH(1).EQ.CPATH(2)) T=TU
	IF (CPATH(1).LT.CPATH(2) .AND. RPATH(1).EQ.RPATH(2)) T=TRIGHT
	IF (CPATH(1).GT.CPATH(2) .AND. RPATH(1).EQ.RPATH(2)) T=TLEFT
	BOARD(RPATH(1),CPATH(1))=T
	IF (FLAG .AND. T.EQ.TD) CALL AUXTD(RPATH(1),CPATH(1))
	IF (FLAG .AND. T.EQ.TU) CALL AUXTU(RPATH(1),CPATH(1))
	L=PTHLEN
	IF (RPATH(L).LT.RPATH(L-1) .AND. CPATH(L).EQ.CPATH(L-1)) T=TD
	IF (RPATH(L).GT.RPATH(L-1) .AND. CPATH(L).EQ.CPATH(L-1)) T=TU
	IF (CPATH(L).LT.CPATH(L-1) .AND. RPATH(L).EQ.RPATH(L-1)) T=TRIGHT
	IF (CPATH(L).GT.CPATH(L-1) .AND. RPATH(L).EQ.RPATH(L-1)) T=TLEFT
	BOARD(RPATH(L),CPATH(L))=T
	IF (FLAG .AND. T.EQ.TD) CALL AUXTD(RPATH(L),CPATH(L))
	IF (FLAG .AND. T.EQ.TU) CALL AUXTU(RPATH(L),CPATH(L))
131	RETURN
	END
	SUBROUTINE DRAW(FLAG)
	INCLUDE 'NETMIN/NOLIST'
	LOGICAL FLAG
	LOGICAL*1 LETTER,LETR
	LOGICAL*1 ASSLET(255,9)
C	LOGICAL*1 XTRA(MAXW),EMPTY
	LOGICAL*1 NEWT
C
C	GRID is logically GRIDR rows by GRIDC columns
C	surrounded on each side by a bordering row and column
C	so that it is physically GRIDR+2 by GRIDC+2.
C
C	BOARD is our drawing board.
C	Since each node is going to be 3 by 8, with one blank line
C	below and to the right,
C	BOARD must be GRIDR*4 by GRIDC*9.
C	For a 24 by 80 screen, this means GRIDR=6 and GRIDC=9.
C	In that case, BOARD is 24 by 81.
C
	DO 3 I=1,255
	DO 3 J=1,9
3	ASSLET(I,J)=0
	DO 2 R=1,PAGSIZ
	DO 2 C=1,WIDTH
2	BOARD(R,C)=' '
	DO 14 R=1,GRIDR
	DO 10 C=1,GRIDC
	NODE=GRID(R+1,C+1)
	IF (NODE.LE.0) GOTO 10
C
C	Draw a box at row r, column c.
C
	XR=GRIDH*(R-1)+1+TMARG
	XC=GRIDW*(C-1)+1+LMARG
	XT=XTENT(NODE)
	HT=HEIGHT(NODE)
	IF (FLAG)
     X	CALL AUXBOX(NODE,XR,XC,HT*GRIDH-VERSP,XT*GRIDW-HORSP)
	IF (.NOT.WANTED(NODE)) GOTO 11
C
C	Draw in the two horizontal lines.
C
	DO 5 J=XC+1,XC+GRIDW*XT-2-HORSP
	BOARD(XR                 ,J)=HB
	BOARD(XR+GRIDH*HT-1-VERSP,J)=HB
5	CONTINUE
C
C	Draw in the two vertical lines.
C
	DO 6 J=XR+1,XR+GRIDH*HT-2-VERSP
	BOARD(J,XC                 )=VB
	BOARD(J,XC+GRIDW*XT-1-HORSP)=VB
6	CONTINUE
C
C	Draw in the four corners.
C
	BOARD(XR                 ,XC                 )=UL
	BOARD(XR                 ,XC+GRIDW*XT-1-HORSP)=UR
	BOARD(XR+GRIDH*HT-1-VERSP,XC                 )=LL
	BOARD(XR+GRIDH*HT-1-VERSP,XC+GRIDW*XT-1-HORSP)=LR
C
C	Draw in the node name.
C
11	NAMS=MIN(NAMSIZ(NODE),BOXW-2)
	NAMC=XC+(GRIDW*XT-2-HORSP-NAMS)/2
	DO 15 J=1,NAMS
15	BOARD(XR+(GRIDH*HT-VERSP-1)/2,NAMC+J)=NAME(NODE,J)
C
C	If the node is not wanted, then just draw in the
C	bottom line and the location.
C
	IF (WANTED(NODE)) GOTO 10
	DO 12 J=XC+1,XC+GRIDW*XT-2-HORSP
	BOARD(XR+GRIDH*HT-1-VERSP,J)=HB
12	CONTINUE
	IF (MASLOC(1,NODE).NE.' ')
     X	BOARD(XR+GRIDH*HT-1-VERSP,XC+GRIDW*XT-4-HORSP)=MASLOC(1,NODE)
	IF (MASLOC(2,NODE).NE.' ')
     X	BOARD(XR+GRIDH*HT-1-VERSP,XC+GRIDW*XT-3-HORSP)=MASLOC(2,NODE)
10	CONTINUE
14	CONTINUE
	IF (CONCNT.EQ.0) GOTO 99
C
C	Draw in the connections that have been made.
C
	DO 20 KNT=1,CONCNT
	NODE1=CONS(KNT,1)
	NODE2=CONS(KNT,2)
	COL1=CPLACE(NODE1)-1
	COL2=CPLACE(NODE2)-1
	XT1=XTENT(NODE1)
	XT2=XTENT(NODE2)
C
C	Node 1 has left corner at (ROW1,COL1) with extent XT1 and height HT1
C	Node 2 has left corner at (ROW2,COL2) with extent XT2 and height HT2
C
C
C	Calculate columns of node 1 and 2 that are closest together.
C	These are called C1 and C2.
C
	DIST=100
	DO 7 CC1=COL1,COL1+XT1-1
	DO 7 CC2=COL2,COL2+XT2-1
	D=IABS(CC1-CC2)
	IF (D.GE.DIST) GOTO 7
	C1=CC1
	C2=CC2
	DIST=D
7	CONTINUE
C
C	Calculate rows of node 1 and 2 that are closest together.
C	These are called R1 and R2.
C
	ROW1=RPLACE(NODE1)-1
	ROW2=RPLACE(NODE2)-1
	HT1=HEIGHT(NODE1)
	HT2=HEIGHT(NODE2)
	DIST=100
	DO 8 RR1=ROW1,ROW1+HT1-1
	DO 8 RR2=ROW2,ROW2+HT2-1
	D=IABS(RR1-RR2)
	IF (D.GE.DIST) GOTO 8
	R1=RR1
	R2=RR2
	DIST=D
8	CONTINUE
C
C	Make R1 less than R2
C
	IF (R1.LT.R2) GOTO 21
	IF (R1.EQ.R2) GOTO 22
C
C	Interchange (R1,C1) and (R2,C2).
C
23	TMP=R1
	R1=R2
	R2=TMP
	TMP=C1
	C1=C2
	C2=TMP
	GOTO 21
C
C	R1=R2, Make C1 less than C2
C
22	IF (C1.GT.C2) GOTO 23
21	XR1=GRIDH*(R1-1)+1+TMARG
	XC1=GRIDW*(C1-1)+1+LMARG
	XR2=GRIDH*(R2-1)+1+TMARG
	XC2=GRIDW*(C2-1)+1+LMARG
	IF (R1.EQ.R2) GOTO 31
	IF (C1-C2) 32,33,34
C
C	Case 1: R1=R2, C1<C2			1  2
C
31	IF (FLAG) CALL AUX12(XR1+BOXH/2,XC1+BOXW-1,
     X	                     XR1+BOXH/2,XC1+BOXW+HORSP)
	BOARD(XR1+BOXH/2,XC1+BOXW-1)=TR
	DO 315 K=1,HORSP
315	BOARD(XR1+BOXH/2,XC1+BOXW-1+K)=HB
	BOARD(XR1+BOXH/2,XC1+BOXW+HORSP)=TL
	GOTO 20
C
C	Case 2: R1<R2, C1<C2			1
C						   2
32	IF (FLAG) CALL AUX14(XR1+BOXH-1    ,XC1+BOXW-1,
     X	                     XR1+BOXH+VERSP,XC1+BOXW+HORSP)
	IF (GIGI) GOTO 328
	IF (DEVTYP.NE.64 .AND. DEVTYP.NE.96 .AND. VERSP.EQ.HORSP)
     X	GOTO 328
	BOARD(XR1+BOXH-1,XC1+BOXW-2)=TD
	XM=XR1+BOXH+(VERSP-1)/2
	DO 322 K=XR1+BOXH,XM-1
322	BOARD(K,XC1+BOXW-2)=VB
	BOARD(XM,XC1+BOXW-2)=LL
	DO 325 K=1,HORSP+2
325	BOARD(XM,XC1+BOXW-2+K)=HB
	BOARD(XM,XC1+BOXW+HORSP+1)=UR
	DO 327 K=XM+1,XR1+BOXH+VERSP-1
327	BOARD(K,XC1+BOXW+HORSP+1)=VB
	BOARD(XR1+BOXH+VERSP,XC1+BOXW+HORSP+1)=TU
	GOTO 20
C
C	Draw connector as \
C
328	DO 329 K=1,HORSP
329	BOARD(XR1+BOXH-1+K,XC1+BOXW-1+K)='\'
C
C	Corner might be free if node is not WANTED.
C
	IF (BOARD(XR1+BOXH-1,XC1+BOXW-1).EQ.' ')
     X	    BOARD(XR1+BOXH-1,XC1+BOXW-1)='\'
	IF (BOARD(XR1+BOXH+HORSP,XC1+BOXW+HORSP).EQ.' ')
     X	    BOARD(XR1+BOXH+HORSP,XC1+BOXW+HORSP)='\'
	GOTO 20
C
C	Case 3: R1<R2, C1=C2			1
C						2
33	IF (FLAG) CALL AUX13(XR1+BOXH-1,    XC1+(BOXW-1)/2,
     X	                     XR1+BOXH+VERSP,XC1+(BOXW-1)/2)
	BOARD(XR1+BOXH-1,XC1+(BOXW-1)/2)=TD
	DO 335 K=1,VERSP
335	BOARD(XR1+BOXH-1+K,XC1+(BOXW-1)/2)=VB
	BOARD(XR1+BOXH+VERSP,XC1+(BOXW-1)/2)=TU
	GOTO 20
C
C	Case 4: R1<R2, C1>C2			   1
C						2
34	IF (FLAG) CALL AUX23(XR1+BOXH-1    ,XC1,
     X	                     XR1+BOXH+VERSP,XC1-HORSP-1)
	IF (GIGI) GOTO 348
	IF (DEVTYP.NE.64 .AND. DEVTYP.NE.96 .AND. HORSP.EQ.VERSP)
     X	GOTO 348
	BOARD(XR1+BOXH-1,XC1+1)=TD
	XM=XR1+BOXH+(VERSP-1)/2
	DO 342 K=XR1+BOXH,XM-1
342	BOARD(K,XC1+1)=VB
	BOARD(XM,XC1+1)=LR
	DO 345 K=1,HORSP+2
345	BOARD(XM,XC1+1-K)=HB
	BOARD(XM,XC1-2-HORSP)=UL
	DO 347 K=XM+1,XR1+BOXH+VERSP-1
347	BOARD(K,XC1-2-HORSP)=VB
	BOARD(XR1+BOXH+VERSP,XC1-2-HORSP)=TU
	GOTO 20
C
C	Draw connector as /
C
348	DO 349 K=1,HORSP
349	BOARD(XR1+BOXH-1+K,XC1-K)='/'
C
C	Corner might be free if node is not WANTED.
C
	IF (BOARD(XR1+BOXH-1,XC1).EQ.' ') BOARD(XR1+BOXH-1,XC1)='/'
	IF (BOARD(XR1+BOXH+HORSP,XC1-HORSP-1).EQ.' ')
     X	    BOARD(XR1+BOXH+HORSP,XC1-HORSP-1)='/'
20	CONTINUE
C
C	Draw dashed lines to indicated non-reachable nodes
C
99	IF (.NOT. FLAG) GOTO 401
	DO 40 R=1,GRIDR
	DO 40 C=1,GRIDC
	NODE=GRID(R+1,C+1)
	IF (NODE.LE.0) GOTO 40
	IF (.NOT.WANTED(NODE)) GOTO 40
	XT=XTENT(NODE)
	HT=HEIGHT(NODE)
	IF (KNOWN(NODE)) GOTO 40
C
C	See whether the bottom row can be dashed.
C	If not, dash the top row.
C
	XR=GRIDH*(R-1)+1+TMARG
	XC=GRIDW*(C-1)+1+LMARG
	DO 41 J=XC+1,XC+GRIDW*XT-2-HORSP
	IF (BOARD(XR+GRIDH*HT-1-VERSP,J).NE.HB) GOTO 42
41	CONTINUE
	XR=XR+GRIDH*HT-1-VERSP
42	DO 43 J=XC+1,XC+GRIDW*XT-3-HORSP
43	BOARD(XR,J)='-'
40	CONTINUE
C
C	Draw in any snakes and/or loop closers
C
401	IF (LOOPCT.EQ.0) GOTO 895
	DO 894 K=1,LOOPCT
	NODE1=LOOP(K,1)
	NODE2=LOOP(K,2)
	CALL SNAKE(NODE1,NODE2,FLAG)
894	CONTINUE
C
C	Draw hooks showing paths that have not been drawn in.
C
895	HOOKS=0
	LETTER='Z'
	DO 60 NODE=1,255
	COUNT=NOPCNT(NODE)
	IF (COUNT.EQ.0) GOTO 60
	HOOKS=HOOKS+COUNT
	IF (.NOT. FLAG) GOTO 60
	R=RPLACE(NODE)-1
	C=CPLACE(NODE)-1
	XT=XTENT(NODE)
	XR=GRIDH*(R-1)+1+TMARG
	XC=GRIDW*(C-1)+1+LMARG
C	No letters right now on GIGI
	IF (GIGI) GOTO 6199
	DO 61 ROW=XR,XR+GRIDH*HT-1-VERSP,GRIDH*HT-1-VERSP
	DO 61 COL=XC+1,XC+GRIDW*XT-2-HORSP
	IF (BOARD(ROW,COL).NE.HB) GOTO 61
	NEWT=TD
	IF (ROW.EQ.XR) NEWT=TU
	ADJ=NOPATH(NODE,COUNT)
	OUTROW=ROW+1
	IF (ROW.EQ.XR) OUTROW=ROW-1
	IF (OUTROW.EQ.0 .OR. OUTROW.EQ.PAGSIZ) GOTO 61
	IF (BOARD(OUTROW,COL).NE.' ') GOTO 61
	IF (RPLACE(ADJ).EQ.0) GOTO 62
	DO 65 I=1,NOPCNT(ADJ)
	IF (NOPATH(ADJ,I).EQ.NODE) GOTO 66
65	CONTINUE
	GOTO 62
66	IF (ASSLET(ADJ,I).NE.0) GOTO 67
	LETTER=LETTER+1
	IF (LETTER.GT.'Z') LETTER='A'
	ASSLET(NODE,COUNT)=LETTER
	LETR=LETTER
	GOTO 68
67	LETR=ASSLET(ADJ,I)
68	BOARD(OUTROW,COL)=LETR
62	BOARD(ROW,COL)=NEWT
C	IF (FLAG .AND. ROW.EQ.XR) CALL AUXHKU(ROW,COL)
C	IF (FLAG .AND. ROW.NE.XR) CALL AUXHKD(ROW,COL)
	COUNT=COUNT-1
	IF (COUNT.EQ.0) GOTO 60
61	CONTINUE
C
C	If can't fit in hook plus a letter, then just fit in a hook.
C
6199	DO 71 ROW=XR,XR+GRIDH*HT-1-VERSP,GRIDH*HT-1-VERSP
	DO 71 COL=XC+1,XC+GRIDW*XT-2-HORSP
	IF (BOARD(ROW,COL).NE.HB) GOTO 71
	NEWT=TD
	IF (ROW.EQ.XR) NEWT=TU
	BOARD(ROW,COL)=NEWT
	IF (FLAG .AND. ROW.EQ.XR) CALL AUXHKU(ROW,COL)
	IF (FLAG .AND. ROW.NE.XR) CALL AUXHKD(ROW,COL)
	COUNT=COUNT-1
	IF (COUNT.EQ.0) GOTO 60
71	CONTINUE
60	CONTINUE
C
C	Draw the board.
C
	IF (FLAG) CALL AUXEND
	IF (.NOT. FLAG) RETURN
	DO 991 I=1,PAGSIZ
	DO 992 MAXCOL=WIDTH,1,-1
	IF (BOARD(I,MAXCOL).NE.' ') GOTO 993
992	CONTINUE
	GOTO 991
993	IF (.NOT.GIGI) CALL DISP(I,MAXCOL)
991	CONTINUE
	RETURN
	END
	SUBROUTINE DISP(ROW,MAXCOL)
	INCLUDE 'NETMIN/NOLIST'
	REAL X,Y
	INTEGER*4 K
C
C	Display row ROW of BOARD, columns 1 to MAXCOL inclusive.
C
	EGUCAD=.FALSE.
	IF (.NOT. EGUCAD) TYPE 100, (BOARD(ROW,J),J=1,MAXCOL)
100	FORMAT(1X,<MAXW>A1)
	RETURN
C
C	Do special stuff for Techtronix
C
C	X=10.0/80.
C	Y=10.0/24.
C	Y=Y/2.
C	DO 2 J=1,MAXCOL
C
C	Do nothing for blank grid item.
C
C	IF (BOARD(ROW,J).EQ.' ') GOTO 2
C
C	Check for one of our known items.
C
C	DO 3 K=1,11
C	IF (BOARD(ROW,J).EQ.CODE(K)) GOTO 7
C3	CONTINUE
C
C	Not a special one, output the corresponding character.
C
C	CALL NOTE(J*X,(PAGSIZ+1-ROW)*Y,BOARD(ROW,J),1)
C	GOTO 2
C7	CALL SYMBP(J*X,(PAGSIZ+1-ROW)*Y,K,Y,0.0)
C2	CONTINUE
C	RETURN
	END
	SUBROUTINE GET
	INCLUDE 'NETMIN/NOLIST'
	DATA NAME/1536*' '/
	CALL GETNOD
	OURNOD=RNUM(1)
	IF (RCOUNT.EQ.1) TYPE 201
201	FORMAT(' none')
	IF (LIST .AND. .NOT. MASTER) TYPE 202
202	FORMAT(/' Nodes adjacent to reachable nodes:'/)
	IF (LIST .AND. MASTER) TYPE 2027
2027	FORMAT(/' Nodes adjacent to selected nodes:'/)
	CALL WANT
	CALL GETLIN
	RETURN
	END
	SUBROUTINE GETNOD
	INCLUDE 'NETMIN/NOLIST'
	LOGICAL*1 CONMSG(3)
	INTEGER*2 INT2
	LOGICAL*1 LOGI(2)
	EQUIVALENCE (INT2,LOGI)
	LOGICAL*1 NODMSG(3)
	LOGICAL*1 REPMSG(600)
	INTEGER*4 STATUS
	DATA CONMSG/2,0,0/
	DATA NODMSG/20,0,-1/
	LOGICAL QSTAT,QREAD,QWRITE,QLINK,QWAIT,QDET
	LOGICAL*1 OURNAM(6)
	RCOUNT=0
	CALL GETNAM(OURNAM,OURSIZ)
C
C	Assign an I/O channel.
C
	CALL GETCHN(CHANEL)
C
C	Request a logical link connection to our NML. (NODE 0)
C
	QSTAT=QLINK(1,CHANEL,0,19,CONMSG,3,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
	QSTAT=QWAIT(1,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
C
C	Send a message to our NML.
C
	QSTAT=QWRITE(1,CHANEL,NODMSG,3,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
	QSTAT=QWAIT(1,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
C
C	Read response from our NML.
C
26	QSTAT=QREAD(1,CHANEL,REPMSG,600,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
	QSTAT=QWAIT(1,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
	IF (REPMSG(1).EQ.2) GOTO 26
	IF (REPMSG(1).LT.0) GOTO 27
	LOGI(1)=REPMSG(5)
	LOGI(2)=0
	NODNUM=INT2
	NAMLEN=REPMSG(7).AND.7
	NAMPTR=7
	PTR=NAMPTR+NAMLEN+1
C
C	Allow name to be unknown
C
	IF (NAMLEN.EQ.0) GOTO 29
	IF (REPMSG(PTR).NE.0) GOTO 26
	PTR=PTR+1
	IF (REPMSG(PTR).NE.0) GOTO 26
	PTR=PTR+1
	IF (REPMSG(PTR).NE.-127) GOTO 26
	PTR=PTR+1
29	NAMSIZ(NODNUM)=NAMLEN
	DO 30 J=1,NAMLEN
30	NAME(NODNUM,J)=REPMSG(J+NAMPTR)
	KNOWN(NODNUM)=.FALSE.
	IF (REPMSG(PTR).NE.0 .AND. REPMSG(PTR).NE.4) GOTO 26
	KNOWN(NODNUM)=.TRUE.
	RCOUNT=RCOUNT+1
	RNUM(RCOUNT)=NODNUM
	IF (RCOUNT.NE.1) GOTO 35
	TYPE 100, (NAME(NODNUM,J),J=1,NAMLEN),DATIME
100	FORMAT(/' Phase 3 Network Topology for Node ',<NAMLEN>A1,
     1	'   on ',20A1)
	IF (LIST) TYPE 101
101	FORMAT(/' Reachable nodes:'//)
	COLCNT=0
	GOTO 26
35	IF (COLCNT.EQ.WIDTH/8 .AND. LIST) TYPE 206
206	FORMAT(/'+',$)
	IF (COLCNT.EQ.WIDTH/8) COLCNT=0
	COLCNT=COLCNT+1
	IF (LIST.AND.NAMSIZ(NODNUM).NE.0)TYPE 205,(NAME(NODNUM,J),J=1,6)
	IF (LIST.AND.NAMSIZ(NODNUM).EQ.0)TYPE 207,NODNUM
205	FORMAT('+',6A1,'  ',$)
207	FORMAT('+',I3.3,'     ',$)
	GOTO 26
C
C	Disconnect the connection
C
27	CALL DETCHN(CHANEL)
	RETURN
	END
	SUBROUTINE GETLIN
	INCLUDE 'NETMIN/NOLIST'
	EXTERNAL SS$_ABORT
	EXTERNAL SS$_INSFMEM,SS$_NOLINKS
	EXTERNAL SS$_REJECT
	EXTERNAL NETMAP_READ,NETMAP_WRITE
	LOGICAL QWAIT,QREAD,QWRITE,QLINK,QDET
	INTEGER*2 INT2
	LOGICAL*1 LOGI(2)
	EQUIVALENCE (INT2,LOGI)
	INTEGER*4 INT4
	INTEGER*2 INTS2(2)
	EQUIVALENCE(INT4,INTS2)
	LOGICAL QSTAT
	LOGICAL*1 LINMSG(3)
	LOGICAL*1 REPMSG(300,PARMAX)
	INTEGER*4 STATUS
	INTEGER*4 EDSC(2)
	LOGICAL*1 ERMSG(256)
	INTEGER*2 ERSIZ
	INTEGER*4 EF
	INTEGER*4 EFMASK
	INTEGER*2 STATE(PARMAX)		! Next state to go to
	INTEGER*2 CHANEL(PARMAX)	! Channel being used
	INTEGER*2 NODCON(PARMAX)	! Node being contacted
	DATA LINMSG/20,1,-2/
	LOGICAL*1 CONMSG(3)
	DATA CONMSG/2,0,0/
	INTEGER*2 IOSB(4,15)
	COMMON /SBLK/ IOSB
C
C	States
C
	DATA ASSIGN,ATTACH,WRITE,READY,READ,DETACH,DISCON,DONE
     X	/1,2,3,4,5,6,7,8/
	EFMASK=0
	DO 2 P=1,LINKS
C
C	Set initial state of each logical link to the ASSIGN state.
C
	STATE(P)=ASSIGN
C
C	Reserve the corresponding event flag.
C	This program uses event flags 1-LINKS.
C	Set the corresponding bit in EFMASK.
C
	EF=P
	EFMASK=EFMASK .OR. (2**EF)
C
C	Set the I/O status block status word non-0 so that
C	we force the logical link into its starting state.
C
	IOSB(1,P)=-1
2	CONTINUE
C
C	RINDEX will range from 1 to RCOUNT.
C	It represnts the index of the next node (in RNUM) to
C	be interrogated.
C
	RINDEX=1
C
C	DONCNT counts how many logical links are done.
C	MALCNT counts how many logical links have malfunctioned.
C
	DONCNT=0
	MALCNT=0
C
C	Go through the LINKS I/O status blocks.
C	Each time we find one that is ready (first word is not 0)
C	we dispatch off to the proper place (depending on the STATE
C	of that logical link).
C
399	DO 400 P=1,LINKS
	IF (IOSB(1,P).EQ.0) GOTO 400
C
C	Dispatch to the appropriate state
C
401	GOTO (410,420,430,440,450,460,470,400), STATE(P)
C
C	*****************
C	*		*
C	*    ASSIGN	*
C	*		*
C	*****************
C
C	The logical link is free, it has never been started yet.
C	If there are no nodes still to be contacted, then
C	mark this logical link as done, and go into the DONE state.
C	Otherwise, assign a channel, and connect to the
C	next node in sequence.
C
410	IF (RINDEX.GT.RCOUNT) GOTO 490
	NODCON(P)=RNUM(RINDEX)
C	TYPE 1234, RINDEX, P, NODCON(P), WANTED(NODCON(P))
C1234	FORMAT(1X,I5,I5,I5,L5)
C
C	Skip this node if it is not WANTED.
C
	IF (.NOT. WANTED(NODCON(P))) GOTO 411
C	IF (NAMSIZ(NODCON(P)).EQ.0) GOTO 411
	IF (DEBUG) TYPE 4005, P
4005	FORMAT(' Assigning channel ',I2)
C
C	Assign an I/O channel.
C
	CALL GETCHN(CHANEL(P))
C
C	Immediately go into the ATTACH state.
C
	GOTO 420
411	RINDEX=RINDEX+1
	GOTO 410
C
C	*****************
C	*		*
C	*    ATTACH	*
C	*		*
C	*****************
C
C	Send a connect message via the current channel to the
C	remote node.
C
420	NODE=NODCON(P)
	IF (DEBUG) TYPE 4004, P, (NAME(NODE,J),J=1,6)
4004	FORMAT(' Logical link ',I2,' trying to connect to node ',6A1)
C
C	Request a logical link connection to remote NML.
C
	QSTAT=QLINK(P,CHANEL(P),NODCON(P),19,CONMSG,3,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
	RINDEX=RINDEX+1
C
C	Next state is the WRITE state.
C
	STATE(P)=WRITE
	GOTO 400
C
C	*****************
C	*		*
C	*     WRITE	*
C	*		*
C	*****************
C
430	IF (DEBUG) TYPE 4006, P
4006	FORMAT(' Logical link ',I2,' back from CONNECT.')
	IF (IOSB(1,P)) GOTO 435
	NODE=NODCON(P)
	IF (LIST) TYPE 439, (NAME(NODE,J),J=1,NAMSIZ(NODE)),':',
     1	(' ',J=NAMSIZ(NODE)+1,7)
439	FORMAT(1X,8A1,$)
	IF (IOSB(1,P).EQ.%LOC(SS$_INSFMEM)) GOTO 703
	IF (IOSB(1,P).EQ.%LOC(SS$_NOLINKS)) GOTO 704
	IF (IOSB(1,P).EQ.%LOC(SS$_REJECT)) GOTO 708
	GOTO 710
435	IF (DEBUG) TYPE 4007, P
4007	FORMAT(' Logical link ',I2,' sending message to remote node.')
C
C	Send a message to remote NML.
C
	QSTAT=QWRITE(P,CHANEL(P),LINMSG,3,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
C
C	Next state is READY
C
	STATE(P)=READY
	GOTO 400
C
C	*****************
C	*		*
C	*     READY	*
C	*		*
C	*****************
C
C	We have just finished sending the request for information
C	to NML and should be ready to start receiving replies.
C	First check that the WRITE succeeded.
C
440	IF (DEBUG) TYPE 4008, P, IOSB(1,P)
4008	FORMAT(' Logical link ',I2,' back from WRITE.  STATUS=',Z4)
	IF (IOSB(1,P).EQ.%LOC(SS$_ABORT)) GOTO 750
	IF (.NOT. IOSB(1,P)) THEN
		CALL LIB$SIGNAL(
     X		%VAL(%LOC(NETMAP_WRITE)),%VAL(1),%VAL(NODCON(P)),
     X		%VAL(IOSB(1,P)))
		GOTO 749
	END IF
C
C	Go immediately into the READ state.
C
	GOTO 451
C
C	*****************
C	*		*
C	*     READ	*
C	*		*
C	*****************
C
C	Check that last read succeeded.
C
450	IF (DEBUG) TYPE 4009, P, IOSB(1,P)
4009	FORMAT(' Logical link ',I2,' back from READ.  STATUS=',Z4)
	IF (IOSB(1,P).EQ.%LOC(SS$_ABORT)) GOTO 180
	IF (.NOT. IOSB(1,P)) THEN
		CALL LIB$SIGNAL(
     X		%VAL(%LOC(NETMAP_READ)),%VAL(1),%VAL(NODCON(P)),
     X		%VAL(IOSB(1,P)))
		GOTO 749
	END IF
C
C	Examine the reply.
C
	NODE=NODCON(P)
	IF (REPMSG(1,P).LT.0) GOTO 750
	IF (REPMSG(1,P).EQ.2) GOTO 451
	PTR=5
	CNT=REPMSG(PTR,P).AND."77
	PTR=PTR+CNT+1
	IF (REPMSG(PTR,P).NE.0) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.0) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.-127) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.0) GOTO 452
	PTR=PTR+1
454	LOGI(1)=REPMSG(PTR,P)
	LOGI(2)=0
	LOBYTE=INT2
	PTR=PTR+1
	LOGI(1)=REPMSG(PTR,P)
	LOGI(2)=0
	HIBYTE=INT2
	TYPE=HIBYTE*256+LOBYTE
C
C	TYPE is the type of data entry that is coming up.
C	Possible types at this point are:
C
C	  0	short record		ignore record (goes to non-NSP node)
C	  1	substate		ignore record
C	400	loopback name		skip it
C	800	adjacent node name	this is what we want
C
	IF (TYPE.EQ.0) GOTO 451
	IF (TYPE.EQ.1) GOTO 451
	IF (ETHER .AND. REPMSG(6,P).EQ.'U') THEN
4500	FORMAT(' Node ',I3, ' (',6A1,') has a connection to ETHERNET.')
		DO 4501 J=1,ECOUNT
		IF (ENODE(J).EQ.NODE) GOTO 4502
4501		CONTINUE
		ECOUNT=ECOUNT+1
		ENODE(ECOUNT)=NODE
		TYPE 4500, NODE, (NAME(NODE,J),J=1,6)
4502		CONTINUE
	ENDIF
	IF (TYPE.EQ.400) GOTO 453
	IF (TYPE.NE.800) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).EQ.-63) GOTO 458
	IF (REPMSG(PTR,P).NE.-62) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.2) GOTO 452
	PTR=PTR+1
	LOGI(1)=REPMSG(PTR,P)
	LOGI(2)=0
	ADJNOD=INT2
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.0) GOTO 452
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.64) GOTO 452
	PTR=PTR+1
C
C	Get count of name of adjacent node.
C
	CNT=REPMSG(PTR,P).AND.7
C
C	Check this name to see if it is the same name we use.
C
	DO 300 J=1,CNT
	IF (NAME(ADJNOD,J).NE.REPMSG(PTR+J,P)) GOTO 301
300	CONTINUE
	IF (CNT.EQ.6) GOTO 302
	DO 309 J=CNT+1,6
	IF (NAME(ADJNOD,J).NE.' ') GOTO 301
309	CONTINUE
	GOTO 302
C
C	Names differ.
C
301	IF (NOTKNT.EQ.MAXNOT) GOTO 302
	NOTKNT=NOTKNT+1
C
C	Store name away.
C
	DO 303 J=1,CNT
303	NONAME(NOTKNT,J)=REPMSG(PTR+J,P)
	NOTYPE(NOTKNT,1)=1
	NOTYPE(NOTKNT,2)=ADJNOD
	NOTYPE(NOTKNT,3)=NODE
	IF (NAMSIZ(ADJNOD).NE.0) NOTYPE(NOTKNT,1)=2
C
C	Ignore node if it is adjacent to itself.
C
302	IF (NODE.EQ.ADJNOD) GOTO 451
C
C	If we didn't already have a name for this node,
C	use this name.
C
4581	IF (DEBUG) TYPE 4013, P,(NAME(NODE,J),J=1,6),
     1	(REPMSG(PTR+J,P),J=1,CNT)
4013	FORMAT(' Logical link ',I2,' hears from ',6A1,' about ',6A1)
	IF (NAMSIZ(ADJNOD).NE.0) GOTO 297
	NAMSIZ(ADJNOD)=CNT
	DO 298 J=1,CNT
298	NAME(ADJNOD,J)=REPMSG(PTR+J,P)
297	IF (CONNUM(NODE).EQ.0) GOTO 294
	DO 295 K=1,CONNUM(NODE)
	IF (CONECT(NODE,K).EQ.ADJNOD) GOTO 296
295	CONTINUE
294	IF (CONNUM(NODE).EQ.MAXFNG) GOTO 2941
C	IF (.NOT.WANTED(ADJNOD)) GOTO 451
	CONNUM(NODE)=CONNUM(NODE)+1
	CONECT(NODE,CONNUM(NODE))=ADJNOD
	GOTO 296
2941	TYPE 2942, NODE, MAXFNG
2942	FORMAT(' Node ',I3,' has more than ',I3,' connections.')
296	IF (CONNUM(ADJNOD).EQ.0) GOTO 292
	DO 291 K=1,CONNUM(ADJNOD)
	IF (CONECT(ADJNOD,K).EQ.NODE) GOTO 451
291	CONTINUE
292	IF (CONNUM(ADJNOD).EQ.MAXFNG) GOTO 2921
	CONNUM(ADJNOD)=CONNUM(ADJNOD)+1
	CONECT(ADJNOD,CONNUM(ADJNOD))=NODE
	GOTO 451
2921	TYPE 2942, ADJNOD, MAXFNG
C
C	Issue another READ
C
451	IF (DEBUG) TYPE 4010, P
4010	FORMAT(' Logical link ',I2,' doing another READ.')
	QSTAT=QREAD(P,CHANEL(P),REPMSG(1,P),300,STATUS)
	IF (.NOT. QSTAT) CALL ERRMSG(STATUS)
C
C	Next state is READ.
C
	STATE(P)=READ
	GOTO 400
C
C	We didn't fully understand NML's message.
C	Print a notice and ignore the message.
C
452	TYPE 4521, (NAME(NODE,J),J=1,6)
4521	FORMAT(' Did not understand NICE dialect from NML at node ',
     1	6A1,':')
	TYPE 4522, (REPMSG(J,P),J=1,IOSB(2,P))
4522	FORMAT(1X,20I4)
	GOTO 451
C
C	Skip loopback name.
C
453	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.64) GOTO 452
	PTR=PTR+1
	KNT=REPMSG(PTR,P)
	PTR=PTR+KNT+1
	GOTO 454
C
C	Target node doesn't know name of node adjacent to it.
C	In this case, get the node number of that adjacent node.
C	See if we know the name of it.  If not, use name of "NODnnn".
C
458	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.2) GOTO 452
	PTR=PTR+1
	LOGI(1)=REPMSG(PTR,P)
	PTR=PTR+1
	IF (REPMSG(PTR,P).NE.0) GOTO 452
	LOGI(2)=0
	ADJNUM=INT2
	IF (NODE.EQ.ADJNOD) GOTO 451
	IF (NAMSIZ(ADJNOD).NE.0) GOTO 4581
	NAMSIZ(ADJNOD)=3
	X=ADJNOD/100
	TMP=ADJNOD-100*X
	Y=TMP/10
	Z=TMP-10*Y
	NAME(ADJNOD,1)=X+'0'
	NAME(ADJNOD,2)=Y+'0'
	NAME(ADJNOD,3)=Z+'0'
	GOTO 4581
C
C	*****************
C	*		*
C	*    DETACH	*
C	*		*
C	*****************
C
460	IF (DEBUG) TYPE 4011, P
4011	FORMAT(' Logical link ',I2,' has completed a DETACH.')
	GOTO 750

C
C	Done with logical link, channel has already been deassigned.
C
490	STATE(P)=DONE
	DONCNT=DONCNT+1
	GOTO 400
C
703	IF (LIST) TYPE 803
	GOTO 749
704	IF (LIST) TYPE 804
	GOTO 749
708	INTS2(1)=IOSB(3,P)
	INTS2(2)=IOSB(4,P)
	IF (LIST) TYPE 808, INT4
	GOTO 755
710	IF (.NOT.LIST) GOTO 755
	EDSC(1)=256
	EDSC(2)=%LOC(ERMSG)
	ERSIZ=1
	ERMSG(1)='?'
	INT4=IOSB(1,P)
	CALL SYS$GETMSG(%VAL(INT4),ERSIZ,EDSC,%VAL(1),)
	TYPE 810, (ERMSG(J),J=1,ERSIZ)
	TYPE 811
	GOTO 755
C
C	Shut this logical link down.
C
749	IF (DEBUG) TYPE 4016, P
4016	FORMAT(' Shutting down broken logical link ',I2)
	MALCNT=MALCNT+1
	GOTO 479
803	FORMAT('+<insufficient dynamic memory>')
804	FORMAT('+<no logical links available>')
808	FORMAT('+<connect rejected, code=',Z8,'>')
810	FORMAT('+<',$,256A1)
811	FORMAT('+>')

180	IF (LIST) TYPE 181
181	FORMAT('+<logical link has been aborted>',$)
C
C	Synchronously disconnect the connection
C
C
C	Report on nodes found.
C
750	NODE=NODCON(P)
	IF (LIST) TYPE 1000, (NAME(NODE,J),J=1,NAMSIZ(NODE)),':',
     1	(' ',J=NAMSIZ(NODE)+1,7)
1000	FORMAT(1X,8A1,$)
	IF (CONNUM(NODE).EQ.0) GOTO 1002
	COLCNT=0
	DO 1001 K=1,CONNUM(NODE)
	ADJ=CONECT(NODE,K)
	COLCNT=COLCNT+1
	IF (COLCNT.EQ.WIDTH/8 .AND. LIST) TYPE 1005
	IF (COLCNT.EQ.WIDTH/8) COLCNT=0
	IF (LIST) TYPE 1003, (NAME(ADJ,J),J=1,6)
1003	FORMAT('+',6A1,'  ',$)
1001	CONTINUE
1002	IF (LIST) TYPE 1004
1004	FORMAT('+')
1005	FORMAT('+'/'         ',$)
755	IF (DEBUG) TYPE 4014, P
4014	FORMAT(' Logical link ',I2,' is disconnecting.')
	QSTAT=QDET(P,CHANEL(P),STATUS)
	IF (.NOT. QSTAT) GOTO 757
C
C	Next state is DISCON
C
	STATE(P)=DISCON
	GOTO 400
757	IF (DEBUG) TYPE 4020, P
4020	FORMAT(' Logical link ',I2,' ignoring failure to disconnect.')
	GOTO 473
C
C	*****************
C	*		*
C	*    DISCON	*
C	*		*
C	*****************
C
470	IF (DEBUG) TYPE 4015, P
4015	FORMAT(' Logical link ',I2,' has completed the disconnection.')
C
C	If we have another node waiting to be contacted, then
C	go connect to it.
C	Otherwise, clear the event flag and disconnect the channel.
C
473	IF (RINDEX.GT.RCOUNT) GOTO 471
	NODCON(P)=RNUM(RINDEX)
C	TYPE 1234, RINDEX, P, NODCON(P), WANTED(NODCON(P))
C
C	Skip this node if it is not WANTED.
C
	IF (.NOT.WANTED(NODCON(P))) GOTO 472
	IF (NAMSIZ(NODCON(P)).EQ.0) GOTO 472
C
C	Go immediately to the ATTACH state.
C
	GOTO 420
472	RINDEX=RINDEX+1
	GOTO 473
471	IF (DEBUG) TYPE 4018, P
4018	FORMAT(' Logical link ',I2,' shutting down normally.')
C
C	Set our STATE to DONE.
C
	STATE(P)=DONE
	DONCNT=DONCNT+1
479	CALL DETCHN(CHANEL(P))
	CALL SYS$CLREF(%VAL(P))
400	CONTINUE
C
C	If all logical links have malfunctioned, we have a problem.
C	If all logical links are done, we are through.
C	Otherwise, we wait for an event flag to be set and
C	then rescan the I/O status blocks.
C
	IF (MALCNT.GE.LINKS) STOP 'all logical links have malfunctioned!'
	IF (DONCNT+MALCNT.GE.LINKS) RETURN
	CALL SYS$WFLOR(%VAL(1),%VAL(EFMASK))
	GOTO 399
	END
