$!---------------------------------------------------------------------
$!            KILL Command -  By Scott B. Sibley   20 Feb 81
$!---------------------------------------------------------------------
$!
$!         Kill Files:  KILL [file-spec][-TRACE|-PROT] | -F | -H
$!
$!     This command file processes multiple files by reading file
$!     names from a saved "DIR" list built according to parameter 1.
$!
$!     GLOBAL SYMBOLS used:  UtilityDir, TempDir, HelpDir, Out
$!     FILES used:  'TempDir'ZZ.KIL, 'HelpDir'kill.hlp
$!
$!---------------------------------------------------------------------
$      ON Warning THEN EXIT
$      it := "''P1'"
$Ask:  IF it .EQS. "" THEN INQ/L it "Enter File to Delete"
$      IF it .EQS. "" THEN EXIT
$      IF "''F$EXT(0,1,it)'" .NES. "-" THEN GOTO NOINFO
$      opt := "''F$EXT(0,2,P1)'"
$      IF opt.EQS."-F" .OR. opt.EQS."-H" THEN GOTO INFO
$      it := "''P2'"
$      IF it .EQS. "" THEN GOTO Ask
$      GOTO GetP
$NOINFO:
$      opt := "''F$EXT(0,2,P2)'"
$!--------------------------------------- Get Path Name
$GetP: DirPath := ""
$      loc = 'F$LOC("]",it)' + 1
$      IF loc .LE. 'F$LEN(it)' THEN DirPath := 'F$EXT(0,loc,it)'
$!------------------------------------------------ Get Directory Title
$      KeepDir := "''F$DIR()'"
$      IF DirPath .NES. "" THEN SET DEF 'DirPath'
$      TitleDir := "''F$DIR()'"
$      IF DirPath .NES. "" THEN SET DEF 'KeepDir'
$!------------------------------------------------ Get Temp File for Dir
$      proc := "''F$PROC()'"        !  Try to get User's name
$      IF "''F$EXT(0,1,proc)'" .EQS. "_" THEN proc := ZZ
$      TempFile := "''TempDir'''proc'.KIL"
$      ON Control_Y THEN GOTO EOF
$      ON Warning THEN GOTO EOF
$!-----------------------------------------------
$      IF opt.NES."".AND.opt.NES."-P".AND.opt.NES."-T" THEN GOTO BadOp
$      SetDefFileType 'it' ".*"
$      VERNUM := "''Version'"
$      IF VERNUM .EQS. "" THEN VERNUM := ";"
$      spec := "''TitleDir'''FileName'''FileType'"
$      DIRECTORY/COL=1/OUT='TempFile' 'spec''VERNUM'
$      OPEN DIRFILE 'TempFile'
$      READ/END=EOF DIRFILE Line
$      READ/END=EOF DIRFILE Line
$      READ/END=EOF DIRFILE Line
$      numfiles = 0
$READ: READ/END=EOF DIRFILE Line
$      IF Line .EQS. "" THEN GOTO Prt
$      numfiles = numfiles + 1
$      IF numfiles .LE. 1 THEN GOTO Next
$      INQ/L it "Multiple Files: ''PrevFile', ''Line' - OK to Delete all?"
$      IF "''F$EXT(0,1,it)'" .EQS. "Y" .AND. opt .EQS. "-T" THEN -
          Out "       KILL - Deleting ''spec';*"
$      IF "''F$EXT(0,1,it)'" .EQS. "Y" .AND. opt .EQS. "-P" THEN -
          SET PROT=(O:RWED) 'spec';*
$      IF "''F$EXT(0,1,it)'" .EQS. "Y" THEN DELETE 'spec';*
$      GOTO EOF
$Next:
$      PrevFile := "''DirPath'''Line'"
$      GOTO READ
$Prt:  IF Version .NES. "" THEN GOTO Ver
$         IF opt .EQS. "-T" THEN Out "       KILL - Deleting ''PrevFile'"
$         IF opt .EQS. "-P" THEN SET PROT=(O:RWED) 'PrevFile'
$         DELETE 'PrevFile'
$         GOTO EOF
$Ver:  IF opt .EQS. "-T" THEN -
          Out "       KILL - Deleting ''spec'''Version'"
$      IF opt .EQS. "-P" THEN SET PROT=(O:RWED) 'spec''Version'
$      DELETE 'spec''Version'
$EOF:  ON Control_Y THEN CONTINUE
$      ON Warning THEN CONTINUE
$      CLOSE DIRFILE
$Del:  DELETE 'TempFile';*
$      EXIT
$BadOp:Out "       KILL - Invalid option:  ''opt'"
$      EXIT
$!------------------------------------------------
$INFO: Out "       Kill Files:  KILL [file-spec][-TRACE|-PROT] | -F | -H"
$      IF "''F$EXT(0,2,P1)'" .NES. "-F" THEN fmt 'HelpDir'kill.hlp TT:
