$!---------------------------------------------------------------------
$!         PUBLISH Command -  By Scott B. Sibley   16 Oct 80
$!---------------------------------------------------------------------
$!
$!     Publish News Article:  PUBLISH [file [topic-name]] | -F | -H
$!
$!     GLOBAL SYMBOLS used:  HelpDir, it, NewsDir
$!     FILES used:  'HelpDir'publish.hlp, 'NewsDir'newsindex.INF
$!                  'NewsDir'NEWSUSER.REC
$!
$!---------------------------------------------------------------------
$      ON Warning THEN EXIT
$      IF 'F$LOC("-",P1) .NE. 'F$LEN(P1) THEN GOTO INFO
$!----------------------------------------------- CHECK FOR FILENAME
$      it := "''P1'"
$      IF it .EQS. "" THEN INQ/L it "Enter File to publish"
$      IF it .EQS. "" THEN EXIT
$      addfile := "''it'"
$!----------------------------------------------- CHECK FOR TOPIC NAME
$      it := "''P2'"
$      IF it .EQS. "" THEN INQ/L it "Enter NEWS topic name"
$      IF it .EQS. "" THEN EXIT
$      addtopic := "''F$EXT(0,9,it)'"
$!----------------------------------------------- GET NEWS TITLE
$      OPEN/ERR=NoFile PUBFILE 'addfile'
$      READ PUBFILE NewsTitle
$      IF "''F$EXT(0,1,NewsTitle)" .NES. "." .AND. -
          "''F$EXT(0,4,NewsTitle)" .NES. " " THEN GOTO FileOK
$      Out "       PUBLISH - 1st line of file must be news title: ",NewsTitle
$      CLOSE PUBFILE
$      EXIT
$NoFile: Out "       PUBLISH - Cannot open file:  ",addfile
$      EXIT
$FileOK:
$      CLOSE PUBFILE
$!----------------------------------------------- UPDATE NEWS INDEX
$      ON control_Y THEN GOTO NoUpdate
$      ON ERROR THEN GOTO NoUpdate
$OpenIndex:
$      OPEN/ERR=NoIndex OLDINDEX 'NewsDir'newsindex.INF
$      GOTO IndexFound
$NoIndex: CREATE 'NewsDir'newsindex.INF
$      OPEN OLDINDEX 'NewsDir'newsindex.INF
$IndexFound:
$      OPEN/WRIT NEWINDEX 'NewsDir'newsindex.COP
$ReadOldIndex:
$      READ/END=InsertTopic OLDINDEX line
$      IF "''F$EXT(0,1,Line)'" .EQS. ")" THEN GOTO WriteIndex
$      IF "''F$EXT(11,1,Line)'" .EQS. "" THEN month := "''F$EXT(2,3,Line)"
$      IF "''F$EXT(11,1,Line)'" .EQS. "" THEN GOTO WriteIndex
$      IF "''F$EXT(2,9,line)" .EQS. addtopic THEN GOTO DuplicateTopic
$WriteIndex:
$      WR NEWINDEX line
$      GOTO ReadOldIndex
$InsertTopic:
$      it := "''F$TIM()'"
$      date := "''F$EXT(3,3,it)' ''F$EXT(0,2,it)'"
$      IF "''F$EXT(2,1,it)'" .NES. "-" THEN -
          date := "''F$EXT(2,3,it)' 0''F$EXT(0,1,it)'"
$      line := "- ''date'"
$      len = 'F$LEN(addtopic)'
$      IF len .EQ. 1 THEN line := "        "'line'
$      IF len .EQ. 2 THEN line := "       "'line'
$      IF len .EQ. 3 THEN line := "      "'line'
$      IF len .EQ. 4 THEN line := "     "'line'
$      IF len .EQ. 5 THEN line := "    "'line'
$      IF len .EQ. 6 THEN line := "   "'line'
$      IF len .EQ. 7 THEN line := "  "'line'
$      IF len .EQ. 8 THEN line := " "'line'
$      user := "''F$PROC()'"
$      IF "''F$EXT(0,1,user)'" .EQS. "_" THEN user := "''F$USER()'"
$      curmonth := "''F$EXT(0,3,date)'"
$      IF curmonth .NES. month THEN WR NEWINDEX ")"
$      IF curmonth .NES. month THEN WR NEWINDEX "( ''curmonth'"
$      WR NEWINDEX "( ''addtopic'", line, "  ''NewsTitle' (''user')"
$      WR NEWINDEX ")"
$      CLOSE OLDINDEX
$      CLOSE NEWINDEX
$      SET PROT=(S:RWED,G:RWED,W:RWED) 'NewsDir'newsindex.COP
$      RENAME 'NewsDir'newsindex.COP .INF
$      PURGE 'NewsDir'newsindex.INF
$      GOTO CopyNewsFile
$DuplicateTopic:
$      Out "       PUBLISH - Topic name already used: ''F$EXT(2,30,line)"
$NoUpdate:
$      CLOSE NEWINDEX
$      DELETE 'NewsDir'newsindex.COP;*
$      CLOSE OLDINDEX
$      EXIT
$!----------------------------------------------- PUBLISH FILE
$CopyNewsFile:
$      ASSI 'addfile' NEWSFILE
$      ON Control_Y THEN GOTO Quit
$      FMT 'NewsDir'NEWSHEADR.INC  'NewsDir''addtopic'.NEW
$Quit: DEAS NEWSFILE
$      SET PROT=(S:RWED,G:RWED,W:RWED) 'NewsDir''addtopic'.NEW
$!----------------------------------------------- NOTIFY USERS
$      OPEN/WRITE NEWSUSER 'NewsDir'NEWSUSER.REC
$      WRITE NEWSUSER addtopic
$      CLOSE NEWSUSER
$      SET PROT=(S:RWED,G:RWED,W:RWED) 'NewsDir'NEWSUSER.REC
$      EXIT
$INFO: Out "       Publish News Article:  PUBLISH [file [topic-name]] | -F | -H"
$      IF "''F$EXT(0,2,P1)" .NES. "-F" THEN fmt 'HelpDir'publish.hlp TT:
