MODULE chario(input,output);

 { Terminal I/O for window package }

 CONST IO$_TTYREADALL = %X003A;
       IO$M_NOECHO    = %X0040;
       IO$M_TRMNOECHO = %X1000;
       IO$_WRITEVBLK  = %X0030;
       IO$M_NOFORMAT  = %X0100;	
       SS$_WASSET     = %X0009;

 TYPE charioquad = PACKED ARRAY [1..4] OF 0..65536;
      string=packed array[1..80] of char;

  FUNCTION sys$qiow ( %IMMED efn: INTEGER;
		      %IMMED chan: INTEGER;
		      %IMMED func: INTEGER;
		      VAR iosb: charioquad;
		      %IMMED astadr: INTEGER;
		      %IMMED astprm: INTEGER;
		      VAR p1: string;
		      %IMMED p2,p3,p4,p5,p6: INTEGER): INTEGER; EXTERN;

  FUNCTION sys$qio  ( %IMMED efn: INTEGER;
		      %IMMED chan: INTEGER;
		      %IMMED func: INTEGER;
		      VAR iosb: charioquad;
		      %IMMED astadr: INTEGER;
		      %IMMED astprm: INTEGER;
		      VAR p1: string;
		      %IMMED p2,p3,p4,p5,p6: INTEGER): INTEGER; EXTERN;

  FUNCTION sys$assign ( %STDESCR devnam: PACKED ARRAY [INTEGER] OF CHAR;
		        VAR chariochan: INTEGER;
			%IMMED acmode: INTEGER;
			%IMMED mbxnam: INTEGER): INTEGER; EXTERN;

  PROCEDURE initchario(VAR chariochan: integer);

    { Initialization routine }

    VAR retcode: integer;

    BEGIN 

      retcode := sys$assign('TT',chariochan,0,0);
      IF not(odd(retcode)) THEN writeln('?Unable to open TT:')
      END;

  PROCEDURE sys$wflor (%IMMED efn,mask: integer); EXTERN;

  FUNCTION sys$readef (%IMMED efn: integer; VAR state: integer): integer;
		      EXTERN;

  PROCEDURE read_complete; EXTERN;	{ TALK program specific }

  FUNCTION getchar(VAR chariochan: integer): char;

    VAR retcode: integer;
        line: string;
        iosb: charioquad;
        done: boolean;
        state: integer;

    BEGIN

      retcode := sys$qio(12,chariochan,
			 IO$_TTYREADALL+IO$M_NOECHO+IO$M_TRMNOECHO,iosb,0,0,
			 line,1,0,0,0,0);
      done := false;
      REPEAT
        sys$wflor(0,%X1800);   		{Wait for EFN 11 or 12}
        retcode := sys$readef(12,state);
        IF retcode = SS$_WASSET THEN done := true
        ELSE read_complete;
        UNTIL done;
      getchar:=line[1]
      END;

  PROCEDURE Putstring(line: string; length: integer; VAR chariochan: integer);

    VAR retcode: integer;
	iosb: charioquad;

    BEGIN
	
      retcode := sys$qiow(0,chariochan,IO$_WRITEVBLK+IO$M_NOFORMAT,iosb,0,0,
			  line,length,0,0,0,0)
      END;

  PROCEDURE Putchar(c: char; VAR chariochan: integer);

    VAR retcode: integer;
        line: string; 
        iosb: charioquad;

  BEGIN

    line[1] := c;
    retcode := sys$qiow(0,chariochan,IO$_WRITEVBLK+IO$M_NOFORMAT,iosb,0,0,
			line,1,0,0,0,0)
    END;

  END.
