(* This is an attempt to emulate the procedure "GOTOXY.PAS"
for the VT-100 in the ANSI mode. GOTOXY.PAS works with the 
Hazeltine Terminals; this still has some problems with the 
VT-100. Comments, especially improvements, to:

Francis J. Monaco
Major, US ARMY
Systems Manager, Computer Graphics Laboratory
Department of Geography and Computer Science
The United States Military Academy
West Point, New York 10996
914-938-2063

*)
PROCEDURE GOTOXY (X (*The column*), Y (*The row*) : INTEGER);

CONST 
      %INCLUDE 'sys$library:libdef.pas'

TYPE 
     THREECH = PACKED ARRAY [1..3] OF CHAR;

VAR 
    ROW, COL, DUMMY: INTEGER;
    ONE, ZERO: INTEGER;
    ESC : CHAR;
    ST : THREECH;

FUNCTION LIB$ERASE_PAGE(I, J: INTEGER): INTEGER;
EXTERN;

FUNCTION LIB$SET_CURSOR(I, J: INTEGER): INTEGER;
EXTERN;

FUNCTION LIB$PUT_SCREEN(ST: THREECH): INTEGER;
EXTERN;
BEGIN
   ONE := 1;
   ZERO := 0;
   ESC := CHR (27);
   IF (X>=0)
      THEN
         BEGIN
            ROW := SUCC (Y);
            COL := SUCC (X);
            DUMMY := LIB$SET_CURSOR(ROW,COL);
         END
      ELSE
         IF (X=-1)
            THEN
               CASE Y OF
                  1: DUMMY := LIB$SET_CURSOR(ONE,ONE) (*Homecursor*);
                  2: DUMMY := LIB$ERASE_PAGE(ONE,ONE) (*Clearscreen*);
                  3: WRITE (ESC,'[',ZERO:1,'m');
                  4: BEGIN
                        ST [1] := ESC;
                        ST [2] := '[';
                        ST [3] := 'K';
                        DUMMY := LIB$PUT_SCREEN (ST);
                     END;
                  5: BEGIN
                        ST [1] := ESC;
                        ST [2] := '[';
                        ST [3] := 'J';
                        DUMMY := LIB$PUT_SCREEN (ST);
                     END;
                  6: GOTOXY (-1,2) (*Clearbackgound*);
                  7: GOTOXY (-1,3) (*Backgroundfollows*);
                  8: WRITE (ESC,'[',ONE:1,'m');
               END
END; (* Gotoxy for VT100 in ANSI Mode *)
