      integer*4 function creprc
     .   (input,output,error,source,prname,uic,n,debug)
      parameter nmax=32
      implicit integer*4 (a-z)
      common/procsub/id(nmax),chan(nmax)
      integer*4 id
      integer*2 chan
      logical debug
      character*(*) input,output,error,source,prname
      external dib$w_unit
      external ss$_abort
      integer*2 mbx
      integer*2 buf(40)
      integer*4 bufdsc(2)
      logical lerror
      logical rd_prc
      data id/nmax*0/
      lerror(i) = mod(i,8).ne.1
c
      bufdsc(1) = 80
      bufdsc(2) = %loc(buf)
      if(id(n).ne.0)then
         if(.not.rd_prc(.false.,n,debug,status))then
            write(6,*)' attempted to create a second process',
     .      n,' before first terminated.'
            creprc = %loc(ss$_abort)
            return
         end if
      end if
C
C
C     limit mailbox messages and buffer space to 100
C     since completion message is 90 bytes long
C
      creprc = sys$crembx(,chan(n),%val(100),%val(100),,,)
      if(debug)write(6,*)' result of create mailbox'
      if(debug)call errmes(creprc)
      if(lerror(creprc))return
      creprc = sys$getchn(%val(chan(n)),,bufdsc,,)
      mbx = buf(%loc(dib$w_unit)/2+1)
      if(debug)write (6,*)' result of getchn on mailbox'
      if(debug)call errmes(creprc)
      if(lerror(creprc))return
      if(uic.ne.0)then
         CALL GET_JPI(.TRUE.,LIST,LMPRIV,LMPRIB,DEBUG)
         if(prname.ne.' ')then
            creprc = sys$creprc(id(n),
     .      source,input,output,error,LMPRIV
     1   ,%val(list),prname,%val(LMPRIB),%val(uic),%val(mbx),%val(64))
         else
            creprc = sys$creprc(id(n),
     .      source,input,output,error,LMPRIV
     1      ,%val(list),,%val(LMPRIB),%val(uic),%val(mbx),%val(64))
         end if
      else
         CALL GET_JPI(.FALSE.,LIST,LMPRIV,LMPRIB,DEBUG)
         if(prname.ne.' ')then
            creprc = sys$creprc(id(n),
     .      source,input,output,error,LMPRIV
     1      ,%val(list),prname,%val(LMPRIB),,%val(mbx),)
         else
            creprc = sys$creprc(id(n),
     .      source,input,output,error,LMPRIV
     1      ,%val(list),,%val(LMPRIB),,%val(mbx),)
         end if
      end if
      if(debug)write(6,*)' result of create process call'
      if(debug)call errmes(creprc)
C
C
      return
      end
C
C
      integer*4 function kilprc(n,debug)
C
      parameter nmax=32
      implicit integer*4 (a-z)
      common/procsub/id(nmax),chan(nmax)
      integer*4 id
      integer*2 chan
      logical debug
C     this entry kills the sub-process.
      if(id(n).eq.0)then
         if(debug)write(6,*)' process ',n,' already ended'
      end if
c     kilprc = sys$delprc(id(n),0)
      call endprc(n,debug)
      return
      end
C
C
C
      integer*4 function gkilprc(n,debug)
C
      parameter nmax=32
      implicit integer*4 (a-z)
      common/procsub/id(nmax),chan(nmax)
      integer*4 id
      integer*2 chan
      logical debug
      external ss$_controly
C     this entry kills the sub-process (gently).
      if(id(n).eq.0)then
         if(debug)write(6,*)' process ',n,' already ended'
      end if
      kilprc = sys$forcex(id(n),,ss$_controly)
      call endprc(n,debug)
      return
      end
C
C
      integer*4 function endprc(n,debug)
C
      parameter nmax=32
      implicit integer*4 (a-z)
      common/procsub/id(nmax),chan(nmax)
      integer*4 id
      integer*2 chan
      logical debug
      logical rd_prc
      external ss$_abort
C
      if(id(n).eq.0)then
         if(debug)write(6,*)' process ',n,' already ended'
         endprc = %loc(ss$_abort)
         return
      end if
      if(.not.rd_prc(.true.,n,debug,status))then
         type *,'internal error in endprc'
         type *,'bad termination mailbox read'
         type *,'on process ',n
         call sys$exit(ss$_abort)
      end if
      endprc = status
      return
      end
C
C
      logical function rd_prc(lwait,n,debug,result)
      parameter nmax=32
      implicit integer*4 (a-z)
      common/procsub/id(nmax),chan(nmax)
      integer*4 id
      integer*2 chan
      common/pr_mail/message(4),status,pid,no,etime(2),acct(8),
     1  user(12),cputim,pagefl,pgflpeak,wspeak,biocnt,diocnt,
     2  volume,stime(2),opid,extra(50)
      byte message,acct,user
      character*30 aetime,astime
      logical debug
      logical lwait
      integer*2 iostat(4)
      external io$_readvblk,io$m_now
      external ss$_normal
      CALL IFERR(LIB$GET_EF(IFLAG),'RD_PRC UNABLE TO GET AN EF')
      ifunc = %loc(io$_readvblk)
      if(.not.lwait)ifunc = ifunc + %loc(io$m_now)
      call sys$qiow(%val(IFLAG),%val(chan(n)),%val(ifunc),iostat,,,
     1     message,%val(90),,,,)
      rd_prc = iostat(1).eq.%loc(ss$_normal)
      CALL IFERR(LIB$FREE_EF(IFLAG),'RD_PRC UANBLE TO FREE EF')
C     type *,'rd_prc & iostat',rd_prc,iostat
      if(rd_prc)then
         call sys$asctim(len,aetime,etime,)
         call sys$asctim(len2,astime,stime,)
         if(debug)call errmes(status)
         if(debug)write(6,200)status,pid,aetime(1:len),acct,user,
     .     cputim/100.,
     1     pagefl,pgflpeak,wspeak,biocnt,diocnt,volume,astime(1:len2),
     2     opid
200      format(' status = ',z10,', pid = ',z10,/,
     1     ' end time was ',a,/,' account = ',8a1,', username = ',12a1,
     2     /,' cpu time = ',f10.2,', pagefaults = ',i10,', peak = ',i10,
     3     /,' working set = ',i10,', bio = ',i10,', dio = ',i10,/,
     4     ' volumes mounted = ',i10,/,' start time = ',a,/,
     5     ' owner process id = ',z10)
C     perform cleanup
C     operations
         id(n) = 0
         call sys$dassgn(%val(chan(n)))
      end if
      result = status
      return
      end
