C
C     This include file contains the contents of the
C     COMMON block used throughout TERMSPEED.
C
C     Note that you can change the parameter NLINES to suit
C     your own configuration if you wish.
C     However, the cost of leaving NLINES fairly large is small
C     ( additional memory space is 13 bytes per line).
C     Also, TERMSPEED insists that the lines you deal with
C     have numbers between TTA0: and TTdn: where
C        d is (NLINES-1)/8 characters greater than A, and
C        n is MOD(NLINES-1,8).
C
      PARAMETER (NLINES = 96)
      IMPLICIT INTEGER*4 (A-Z)
      COMMON/CHAN/HANGUP_TIME(2),GRAB_AST_ADDR,GRAB_TIME(2),
     .   SPEED_TIME(2),
     .   HOLD(NLINES),HANGUP(NLINES),ICHAN(NLINES),MCHAN(NLINES),
     .   B(NLINES)
C        The variables ending in _ADDR hold the addresses of the AST
C        routines of the same names.  These are needed since the AST
C        routine itself cannot determine its own address!
C        The variables ending in _TIME hold the binary delta times used
C        in queueing the associated ASTs.
C        HOLD indicates that we are trying to handle a given line.
C        HANGUP indicates that if our time expires we should hangup
C        a given line (this is cancelled whenever we get a character).
C        ICHAN holds the channel number assigned to the terminal line.
C        MCHAN holds the channel number assigned to the temporary
C        mailbox (to get the termination message) associated with the line.
C        B is a 1 byte buffer to read a character from the terminal.
      INTEGER*2 ICHAN,MCHAN
      LOGICAL HOLD,HANGUP
      BYTE B
