$	VER = 'F$VERIFY(0)
$!
$!		Start of [DECUS.COPYING]COPYTAPE.COM
$!
$!	Written by:  J. L. Bingham
$!                   Mantech International
$!                   2320 Mill Road
$!                   Alexandria, VA 22314
$!                   Telephone (703) 960-8900
$!
$! USAGE:  This command procedure copies container files from a tape made with
$!   the MAKETAPE.COM procedure, restoring the directory structure of the original
$!   directory trees.  To use, initiate the procedure and follow the prompts.
$!
$	DEFDIR := 'F$LOGICAL("SYS$DISK")''F$DIRECTORY()'
$!
$	INQUIRE DRIVE "Enter the name of the tape drive being used"
$	INQUIRE LABEL "Enter the tape label"
$! Rewind the tape
$	ON ERROR THEN $GOTO NOTMOUNTED
$	DISMOUNT/NOUNLOAD 'DRIVE'
$CONTINUE:
$	ON CONTROL_Y THEN $GOTO CTLY
$	ON ERROR THEN $GOTO ERROR
$	MOUNT 'DRIVE' 'LABEL' TAPE
$!
$	INQUIRE/NOPUNC ANS "Use the DIRLIS.DAT from the tape? "
$	IF ANS THEN $WRITE SYS$OUTPUT " "
$	IF ANS THEN $COPY TAPE:DIRLIS.DAT *
$!
$	INQUIRE/NOPUNC ANS "Display the list of directories? "
$	IF ANS THEN $TYPE DIRLIS.DAT
$!
$	OPEN DIRLIS DIRLIS.DAT
$!
$	WRITE SYS$OUTPUT "The directories can be copied with their original names"
$	WRITE SYS$OUTPUT "and structure or under a directory of your choice.  If""
$	WRITE SYS$OUTPUT "you are copying the whole tape the original structure is "
$	WRITE SYS$OUTPUT "recommended."
$TRYAGAIN:
$	INQUIRE STRUC "Indicate ORIGINAL or NEW"
$	IF "''STRUC'" .EQS. "ORIGINAL" THEN $GOTO DIROK
$	IF "''STRUC'" .NES. "NEW" THEN $GOTO TRYAGAIN
$!
$START:
$	ROOTDIR := 'F$LOGICAL("SYS$DISK")''F$DIRECTORY()'
$	WRITE SYS$OUTPUT "Tape will be loaded with ''ROOTDIR' as the root node."
$	WRITE SYS$OUTPUT "If this is not satisfactory enter the name of the disired"
$	INQUIRE NEWROOT "root directory.  (Include square brackets)"
$	WRITE SYS$OUTPUT " "
$	IF "''NEWROOT'" .EQS. "" THEN $GOTO DIROK
$		SET DEFAULT 'NEWROOT
$		GOTO START
$DIROK:
$!
$	INQUIRE/NOPUNC ALL "Copy all of the directories? "
$	IF .NOT. ALL THEN $WRITE SYS$OUTPUT "Enter the most significant part of the name of"
$	IF .NOT. ALL THEN $INQUIRE WANT " the container files desired"
$!
$	READ DIRLIS LINE
$	READ DIRLIS LINE
$	READ DIRLIS LINE
$!
$LOOP:
$	READ/END_OF_FILE=EXIT DIRLIS ORIGDIR
$	READ/END_OF_FILE=EXIT DIRLIS DIR
$	READ/END_OF_FILE=EXIT DIRLIS FILE
$	READ/END_OF_FILE=EXIT DIRLIS LINE
$	IF 'F$LOCATE(WANT,FILE) .NE. 0 THEN $ GOTO LOOP
$!
$	SPACE = 'F$LOCATE("  ",ORIGDIR)
$	ORIGDIR := 'F$EXTRACT(0,SPACE,ORIGDIR)
$	IF "''DIR'" .EQS. "[]" THEN $DIR := 'ROOTDIR
$	IF "''STRUC'" .EQS. "ORIGINAL" THEN $DIR := 'ORIGDIR
$	SET VERIFY
$	IF "''LINE'" .NES. "NODE" THEN $CREATE/DIR 'DIR'
$	IF $STATUS .EQ. %X10911293 THEN $GOTO DIR_EXISTS
$DOIT:
$	ON ERROR THEN $CONTINUE
$	SET DEFAULT 'DIR'
$!
$	MCR RST *.*;*/FR=TAPE:'FILE'
$!
$	WRITE SYS$OUTPUT " "
$	DUMMY = 'F$VERIFY(VER)
$	IF "''STRUC'" .EQS. "NEW" THEN $SET DEFAULT 'ROOTDIR'
$	GOTO LOOP
$!
$!
$!		Exit and condition handling sections
$!
$NOTMOUNTED:
$	ALLOCATE 'DRIVE' TAPE
$	GOTO CONTINUE
$!
$!
$DIR_EXISTS: 
$	DUMMY = 'F$VERIFY(0)
$	INQUIRE/NOPUNC ANS "''DIR' already exists.  COPY, SKIP or EXIT? "
$	IF "''ANS'" .EQS. "EXIT" THEN $GOTO ERROR
$	IF "''ANS'" .EQS. "SKIP" THEN $GOTO LOOP
$	IF "''ANS'" .NES. "COPY" THEN $GOTO DIR_EXISTS
$		SET VERIFY
$		GOTO DOIT
$!
$ERROR:
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT "*************** OPERATION INCOMPLETE **************"
$	GOTO EXIT2
$!
$CTLY:
$	ON CONTROL_Y THEN $CONTINUE
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT " ********** ABORTED BY CONTROL Y **********"
$	GOTO EXIT2
$!
$EXIT:
$	WRITE SYS$OUTPUT " "
$	WRITE SYS$OUTPUT " *** COPYING COMPLETE ***"
$EXIT2:
$	WRITE SYS$OUTPUT " "
$	ON ERROR THEN $CONTINUE
$	CLOSE DIRLIS
$	DUMMY = 'F$VERIFY(VER)
$	DISMOUNT/NOUNLOAD TAPE
$	DEALLOCATE TAPE
$	SET DEFAULT 'DEFDIR'
$!
$!		End of [DECUS.COPYING]COPYTAPE.COM
$!
