C	PIX.FOR--
C	Six FORTRAN routines to draw useless pictures that fit on 8.5"
C	paper--
C	RING, DECA, MOUNDS, RRECT, EDESIGN, & MOIRE
C
C	by M. Gooley
C
C	All output is to FOR003.DAT; modify if necessary.  See VPLOT 
C	Guide and DEMO.FOR for suggestions, details, &c.
C	This routine plots a ring formed by a rotated square:
	SUBROUTINE RING
	DIMENSION X(144),Y(144)
	INTEGER*2 IX
	CALL PLOTS (8.5,8.5,3)
	DO 1 I=1,144
	ANGLE=FLOATJ(I)*.0436322
	X(I)=COS(ANGLE)*4.
1	Y(I)=SIN(ANGLE)*4.
	CALL PLOT (4.25,4.25,-3)
	DO 2 I=1,36
	CALL PLOT (X(I),Y(I),3)
	CALL PLOT (X(I+36),Y(I+36),2)
	CALL PLOT (X(I+72),Y(I+72),2)
	CALL PLOT (X(I+108),Y(I+108),2)
	CALL PLOT (X(I),Y(I),2)
2	CONTINUE
	CALL PLOT (0.,0.,999)
	RETURN
	END
C	Concentric decagons, sort of...
	SUBROUTINE DECA
	DIMENSION X(13),Y(13)
	ANGLE=3.1415927/5.
	DO 1 I=0,9
	A=ANGLE*FLOATJ(I)
	X(I+1)=4.*COS(A)
1	Y(I+1)=4.*SIN(A)
	X(11)=X(1)
	Y(11)=Y(1)
	X(12)=0.
	Y(12)=0.
	X(13)=1.
	Y(13)=1.
	K=0
	CALL PLOTS (8.5,8.5,3)
	CALL PLOT (4.25,4.25,-3)
15	CALL LINE (X,Y,11,1,0,0)
	K=K+1
	IF (K.GT.50) GO TO 3
	X0=X(1)
	Y0=Y(1)
	DO 2 I=1,9
	X(I)=(X(I)+X(I+1))/2.
	Y(I)=(Y(I)+Y(I+1))/2.
2	CONTINUE
	X(10)=(X(10)+X0)/2.
	Y(10)=(Y(10)+Y0)/2.
	X(11)=X(1)
	Y(11)=Y(1)
	GO TO 15
3	CALL PLOT (0.,0.,999)
	RETURN
	END
C	A design using CIRCL:
	SUBROUTINE MOUNDS
	CALL PLOTS (8.5,8.5,3)
	DO 1 I=1,20
	R=FLOATJ(I)/10.
	CALL CIRCL(3.75,3.75,45.,405.,R,R,0.)
	CALL CIRCL(4.75,3.75,135.,495.,R,R,0.)
	CALL CIRCL(3.75,4.75,-45.,315.,R,R,0.)
	CALL CIRCL(4.75,4.75,-135.,225.,R,R,0.)
1	CONTINUE
	CALL PLOT (0.,0.,999)
	RETURN
	END
C	A rotating rectangle changes size...
	SUBROUTINE RRECT
	CALL PLOTS (8.,8.,3)
	DO 1 I=0,89
	F=FLOATJ(I)
	W=(F+1.)/30.
	ANGLE=F*4.
	CALL RECT (4.,4.,3.,W,ANGLE,3)
1	CONTINUE
	CALL PLOT (0.,0.,999)
	RETURN
	END
C	Ellipses becoming gradually more circular...
	SUBROUTINE EDESIGN
	CALL PLOTS (11.,8.5,3)
	DO 1 I=0,20
	F=FLOATJ(I)/10.
	CALL ELIPS(8.5+F,4.25,3.+F,3.-F,0.,0.,360.,3)
1	CONTINUE
	CALL PLOT (0.,0.,999)
	RETURN
	END
C	Four sets of multiple spirals interfere with each other...
	SUBROUTINE MOIRE
	CALL PLOTS(9.,8.5,3)
	CALL PLOT (4.25,4.25,-3)
	DO 1 J=-1,1,2
	DO 1 K=-1,1,2
	DO 1 I=0,350,10
	START=FLOATJ(I)
	QUIT=FLOATJ(I+540)
	CALL CIRCL (FLOATJ(J)*.1,FLOATJ(K)*.1,START,QUIT,0.,3.75,0.)
1	CONTINUE
	CALL PLOT (0.,0.,999)
	RETURN
	END
